/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>


#include <time.h>



#include "nSX2.h"
#include "PS2Edefs.h"


#include "GUI_LogFunctions.h"



/* Output File Functions        Shadowpri */

FILE  * outputfile;    
//char    outputfilename[256]; 

_u8		EnableLogFile = TRUE;
_u8		EmulationStart = FALSE;





/***************************************************************************/
/* LOG FILE																   */	
/***************************************************************************/

void OpenOutputFile( ) {
    outputfile = fopen(LOG_FILE_NAME, "w");
//	sprintf(outputfilename,"%s",filename);
}


void PrintToOutputFile ( char * ftext  , ...   ) {
    va_list ap;
    va_start (ap, ftext);
    vfprintf (outputfile, ftext, ap);
    va_end (ap);
 
}


void CloseOutputFile( ) {	fclose( outputfile ) ; }


void	LogFile_Add_Safe( char * fText ) {

	outputfile = fopen(LOG_FILE_NAME, "a");
    fprintf (outputfile, "%s\n",fText);
	fflush( outputfile );
	fclose( outputfile ) ;

}


/***************************************************************************/
/* 															   				*/	
/***************************************************************************/


/*


void EMU_Log ( char * ftext  , ...   ) {
	char EMU_LogText[ FILE_NAME_LENGHT ];

	va_list ap;
  	va_start (ap, ftext);
   	vsprintf (EMU_LogText, ftext, ap);
   	va_end (ap);

	sprintf(EMU_LogText,"%s\n",EMU_LogText);
	PrintToEmuOutput (  EMU_LogText ); 

}
*/

void PrintToOpcodeOutput 	(  char * ftext ) { }
void PrintToDmaOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToBIOSOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToGIFOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToGSOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToINTCOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToTIMEROutput 	(  char * ftext ) { AddLogLine(ftext); }
void PrintToVIFOutput 		(  char * ftext ) { AddLogLine(ftext); }
void PrintToLOADEROutput 	(  char * ftext ) { AddLogLine(ftext); }


/***************************************************************************/
/* 												   							*/	
/***************************************************************************/

void ShowMessage(char *fmt, ...) {
	va_list list;
	char tmp[512];

	va_start(list,fmt);
	vsprintf(tmp,fmt,list);
	va_end(list);
	MessageBox(0, tmp, "nSX2 Message", 0);
}


