/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <windows.h>
#include <commctrl.h>	
 
#include "resource.h"
#include "main.h"
#include "GUI_LogWindow.h"
#include "nsx2.h"
#include "DebugView.h"

const char g_szClassNameLog[] = "nSX2LogClass";


HWND hEdit ;
HWND hEditLog ;
static int line=0;
int extLogger ; 


///////////////////////// Inner Logger window ////////////////////////////////////

/* Log Window Creation */

int CreateInnerLogger( HWND hwnd ) {

	WORD factor;
	HMODULE hDLL ;
	PSLWA pSetLayeredWindowAttributes;
	
	DWORD dwWinVersion,dwWindowsMajorVersion,dwWindowsMinorVersion ;


    WNDCLASSEX wc;
    MSG Msg;

    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProcLog;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = App_hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_szClassNameLog;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hEditLog = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        g_szClassNameLog,
        "nSX2 : Log",
        WS_OVERLAPPEDWINDOW ,
        CW_USEDEFAULT, CW_USEDEFAULT, 600, 275,
        NULL, NULL, App_hInstance, NULL);

    if(hEditLog == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }


    hEdit = CreateWindowEx( 	0L,
                            	WC_LISTVIEW,
                                "",
                                WS_VISIBLE | WS_CHILD | WS_BORDER |
                                LVS_REPORT | WS_EX_CLIENTEDGE,
                                0,
                                0,
                                630,
                                275,
                                hEditLog,
                                (HMENU)IDC_MAIN_EDIT,
                                App_hInstance,
                                NULL );


	if(hEdit == NULL)
		MessageBox(hwnd, "Could not create edit box.", "Error", MB_OK | MB_ICONERROR);

	
	/* Get the Window Version */
	dwWinVersion = GetVersion();
 	dwWindowsMajorVersion =  (DWORD)(LOBYTE(LOWORD(dwWinVersion)));
	dwWindowsMinorVersion =  (DWORD)(HIBYTE(LOWORD(dwWinVersion)));


	/* It seems only working for Win2K and WinXP*/
/*
	if ( (dwWindowsMajorVersion == 0x5 ) && ( dwWindowsMinorVersion == 0x0) ) {

		// Window Transparent Stuff 
		// http://www.codeproject.com/win32/Quaker1.asp 
		factor = 200;
		SetWindowLong (hEditLog , GWL_EXSTYLE ,  GetWindowLong (hEditLog , GWL_EXSTYLE ) | WS_EX_LAYERED ) ;
	
		hDLL = LoadLibrary ("user32");
		pSetLayeredWindowAttributes = 
    		(PSLWA) GetProcAddress(hDLL,"SetLayeredWindowAttributes");
		if (pSetLayeredWindowAttributes != NULL) {
 
    		pSetLayeredWindowAttributes (hEditLog, 
        		RGB(200,200,200), factor, LWA_COLORKEY|LWA_ALPHA);
		}


	}
*/
//    ShowWindow(hEditLog, SW_SHOW	);
//    UpdateWindow(hEditLog);
    
    InitLogWindow();

    return 1 ;
}

LRESULT CALLBACK WndProcLog(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {

		/* Resize the List Box to the Window */
    	case WM_SIZE:
    	{
        	HWND hEdit;
        	RECT rcClient;

        	GetClientRect(hwnd, &rcClient);

        	hEdit = GetDlgItem(hwnd, IDC_MAIN_EDIT);
        	SetWindowPos(hEdit, NULL, 0, 0, rcClient.right, rcClient.bottom, SWP_NOZORDER);
    	}
    	break;
 
		/* On Close Window */
        case WM_CLOSE:
          HideLogWindow();
        break;


        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
 
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

///////////////// External Logger DLL ////////////////////////////////////////// 
 
int CreateExtLogger() 
{
    HMODULE DVHandle;
    
    DVHandle = LoadLibrary("plugins/debugview.dll");
    if (DVHandle) {
        FileLog = (void (__cdecl *)(char *, ...)) GetProcAddress(DVHandle, "FileLog");
        if (!FileLog) return 0;
        OpenDV = (HWND (__cdecl *)(HINSTANCE)) GetProcAddress(DVHandle, "OpenDV");
        if (!OpenDV) return 0;
        DVMsg = (void (__cdecl *)(int, char *, ...)) GetProcAddress(DVHandle, "DVMsg");
        if (!DVMsg) return 0;
        CloseDV = (void (__cdecl *)(void)) GetProcAddress(DVHandle, "CloseDV");
        if (!CloseDV) return 0;
        ShowDV = (void (__cdecl *)(int)) GetProcAddress(DVHandle, "ShowDV");
        if (!ShowDV) return 0;
        SetUserIcon = (void (__cdecl *)(int, HICON)) GetProcAddress(DVHandle, "SetUserIcon");
        if (!SetUserIcon) return 0;
        SetUserIconName = (void (__cdecl *)(int, char*)) GetProcAddress(DVHandle, "SetUserIconName");
        if (!SetUserIconName) return 0;
        
        OpenDV( DVHandle);
//        ShowDV( DV_HIDE ) ;

        return 1;        
   }
   else {
      return 0;
   }
}

////////////////////////////////////////////////////////////////////////////////


/* List Box Initialisation */
void InitLogWindow()
{ 
      LV_COLUMN lvC;   
      lvC.mask = LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;

      lvC.fmt = LVCFMT_LEFT;
      lvC.cx = 600;
      lvC.pszText = "Log Output";
      ListView_InsertColumn( hEdit, 0, &lvC );
}



/* Show / Hide Management */
void ShowLogWindow()	{ 
    if (!extLogger) {
       ShowWindow(hEditLog,SW_SHOW);	
       }
    else {
       ShowDV( DV_SHOW ) ;
       }
    }
void HideLogWindow()	{    
    if (!extLogger) {
        ShowWindow(hEditLog,SW_HIDE);  
        }
    else {
       ShowDV( DV_HIDE ) ;
    }    
}


void ShowHideLogWindow()
{
    DWORD dwStyle ;
    dwStyle = GetWindowLong(hEditLog,GWL_STYLE);
    if (!extLogger) {
        if (dwStyle & WS_VISIBLE)
         {
             HideLogWindow();
         }
        else 
         {
             ShowLogWindow();
         }
    }
    else 
    {
        ShowDV( DV_AUTO ) ;
    }
}



/* Add Text to Log */
void AddLogLine(char *Str, ...)
{
   LV_ITEM lvI;                     
   int i;	

            
   char Msg[800];
	
   va_list ap;
   va_start( ap, Str );
   _vsnprintf( Msg, sizeof(Msg), Str, ap );
   va_end( ap );
	  
   if (debug_file) {
	  	  LogFile_Add_Safe( Msg );
   }



	for ( i = 0 ; i < strlen( Msg ) ; i++ )	{
		if ( Msg[ i ] == '\n' ) Msg[ i ] = ' ';		//carrier retirn
		if ( Msg[ i ] == '\r' ) Msg[ i ] = ' ';
		if ( Msg[ i ] == '\t' ) Msg[ i ] = ' ';		//tab
	}
   
   if (!extLogger)
   { 
      // - If Str is NULL listbox is cleared.

      if(!Str)
      {
          ClearLogWindow() ;
          return;
      }
      lvI.mask = LVIF_TEXT; // | LVIF_IMAGE;
      lvI.iItem = line;
      lvI.iSubItem = 0;
      lvI.iImage = 0;
      lvI.pszText=Msg;

      ListView_InsertItem( hEdit, &lvI );
      ListView_EnsureVisible( hEdit, line, FALSE);

      line++;
   }
   else {
      DVMsg( DV_INFO, Msg) ;
   }   

}

/* Clear Text in Log */
void ClearLogWindow()
{
   if (!extLogger)
   {  
     ListView_DeleteAllItems( hEdit );
     line=0;
     return;
   }  
}


int GUI_CreateLogWindow( HWND hwnd )  {
    extLogger = CreateExtLogger() ;
    
    if (!extLogger) { //  Not found external log dll,or failed to load it 
        CreateInnerLogger( hwnd ) ;
    }
    
	//ShowHideLogWindow();

}

void CloseLogWindow()
{
    if (!extLogger) {
        
    }
    else {
        CloseDV() ;
    }
    
}


