/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef _MEMORY_MAN_H
#define _MEMORY_MAN_H


/********************************************************************************************
							MEMORY DECLARATIONS
*********************************************************************************************/
#define DATA_QUAD		1		//128 bits	
#define DATA_DW			2		//64 bits	
#define DATA_DWH		32		//64 bits
#define DATA_W			4		//32 bits
#define DATA_HW			8		//16 bits
#define DATA_B			16		//8 bits

_u8 MipsMemoryAlloc				(void);
_u8 MipsSpecialAreaMemoryAlloc	(void);
_u8 MipsGSAreaMemoryAlloc		(void);
_u8 MipsBiosMemoryAlloc			(void);

void 	FreeAllMemory			(void);
void 	CopyProgramToMemory		(void);
void 	CopySectionToMemory 	(void);
void 	CopyBiosToMemory 		(void);

void	MipsMemoryWrite 	( _u128 fVal,	_u8 fDataType,	_u64 fBase, 	int fOffset );
void	MipsSpecialMemWrite	( _u8 * Mem,	_u128  fVal,	_u8 fDataType, 	_u64 fBase,	int fOffset );
void	MipsGSAreaMemWrite	( _u8 * Mem,	_u128  fVal,	_u8 fDataType, 	_u64 fBase,	int fOffset );
void  	MipsBiosAreaMemWrite( _u8 * Mem, 	_u128  fVal, 	_u8 fDataType, 	_u64 fBase, int fOffset );
void	MipsMemoryWriteDW 	( _u8 * Mem,	_u64 fVal,		_u64 fAdd );
void	MipsMemoryWriteW  	( _u8 * Mem,	_u64 fVal,		_u64 fAdd );
void	MipsMemoryWriteHW  	( _u8 * Mem,	_u64 fVal,		_u64 fAdd );
void	MipsMemoryWriteB  	( _u8 * Mem,	_u64 fVal,		_u64 fAdd );

void	MipsMemoryRead 		( _u128 * fVal,	_u8 fDataType,	_u64 fBase,		int fOffset );
void	MipsSpecialMemRead	( _u8 * Mem,	_u128 * fVal,	_u8 fDataType,	_u64 fBase,	int fOffset );
void	MipsGSAreaMemRead	( _u8 * Mem,	_u128 * fVal,	_u8 fDataType,	_u64 fBase,	int fOffset );
void	MipsBiosAreaMemRead	( _u8 * Mem,	_u128 * fVal,	_u8 fDataType,	_u64 fBase,	int fOffset );

void 	MipsMemoryReadDQ 	( _u8 * Mem,  	_u128 * fVal , 	_u64 fAddr );
void	MipsMemoryReadDWH 	( _u8 * Mem,	_u128 * fVal,	_u64 PhysicalAdd );
void	MipsMemoryReadDW 	( _u8 * Mem,	_u128 * fVal,	_u64 PhysicalAdd );
void	MipsMemoryReadW 	( _u8 * Mem,	_u128 * fVal,	_u64 fAddr );
void	MipsMemoryReadHW 	( _u8 * Mem,	_u128 * fVal,	_u64 fAddr );
void	MipsMemoryReadB 	( _u8 * Mem,	_u128 * fVal,	_u64 fAddr );


void  MipsSPRMemRead( _u8 * Mem, _u128 * fVal  , _u8 fDataType , _u64 fBase , int fOffset );
void  MipsSPRMemWrite( _u8 * Mem , _u128  fVal  , _u8 fDataType , _u64 fBase , int fOffset );


#endif
