/**********************************************************************************
Common sif plugin spec, version #1.0 maintained by FiRES (FiRES-@gmx.de)
***********************************************************************************

Notes:
------

None

**********************************************************************************/
#ifndef _SIF_H_INCLUDED__
#define _SIF_H_INCLUDED__



#if defined(__cplusplus)
extern "C" {
#endif

/* Plugin types */
#define PLUGIN_TYPE_GS    1
#define PLUGIN_TYPE_SIF    2

#define EXPORT      __declspec(dllexport)
#define CALL      _cdecl

/***** Structures *****/
typedef struct {
 WORD Version;        /* Set to 0x0100 */
 WORD Type;           /* Set to PLUGIN_TYPE_SIF */
 char Name[100];      /* Name of the DLL */

} PLUGIN_INFO;



typedef void* (*TGetMemoryPointer)(DWORD _dwAddress);
typedef void (*TSignalSema)(int _dwSemaId);
typedef void (*TLog)(char* _pMessage);


/* TO TEST */
typedef void (*TCallFunction)( SifRpcCall * _pRPCCall, u32* _pIn,  u32* _pOut);
//typedef void (*TCallFunction)( struct SifRpcCall * _pRPCCall, u32* _pIn,  u32* _pOut);

typedef struct 
{
 DWORD   dwBindNumber;  /* Bindnumber (eg: 0x80000006 = MODLOAD)*/
 TCallFunction pCallFunction;  /* pointer to the call function*/
} SModuleBind;


typedef struct
{
 TGetMemoryPointer pGetMemoryPointer;
 TSignalSema   pSignalSema;
 TLog    pLog;
} SSifInitialize;


/*
EXPORT void CALL GetDllInfo (PLUGIN_INFO * _PluginInfo);

EXPORT void CALL CloseDLL (void);

EXPORT void CALL DllAbout (HWND _hParent);

EXPORT void CALL DllConfig (HWND _hParent);

EXPORT void CALL DllTest (HWND _hParent);

EXPORT void CALL Initialize (SSifInitialize _SifInitialize);

EXPORT BOOL CALL BindModule (SModuleBind* _pModuleBind); 

EXPORT void CALL SetRPCVersion (char* _ioprp); 

EXPORT int CALL Run_DVD ( void );

EXPORT unsigned long CALL GetElfStartAdress( void );
*/


#if defined(__cplusplus)
}
#endif


typedef void (CALLBACK* _SIFGetDllInfo)(PLUGIN_INFO * _PluginInfo);
typedef void (CALLBACK* _SIFCloseDLL)(void);
typedef void (CALLBACK* _SIFDllAbout)(HWND _hParent);
typedef void (CALLBACK* _SIFDllConfig)(HWND _hParent);
typedef void (CALLBACK* _SIFDllTest)(HWND _hParent);
typedef void (CALLBACK* _SIFInitialize)(SSifInitialize _SifInitialize);
typedef BOOL (CALLBACK* _SIFBindModule)(SModuleBind* _pModuleBind); 
typedef void (CALLBACK* _SIFSetRPCVersion)(char* _ioprp); 
typedef int (CALLBACK* _SIFRun_DVD)(void);
typedef unsigned long (CALLBACK* _SIFGetElfAdd)(void);


_SIFGetDllInfo	  			SIFGetDllInfo;
_SIFCloseDLL	  			SIFCloseDLL;
_SIFDllConfig     			SIFDllConfig;
_SIFDllTest       			SIFDllTest;
_SIFInitialize    			SIFInitialize;
_SIFBindModule	  			SIFBindModule;
_SIFSetRPCVersion 			SIFSetRPCVersion;
_SIFRun_DVD		  			SIFRun_DVD;
_SIFDllAbout      			SIFDllAbout;
_SIFGetElfAdd				SIFGetElfAdd;



#endif

