/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#ifndef _VU_H
#define _VU_H


/* Define or Undefine if you want INTC LOG */
#define	VU_COP2_LOG	VU_COP2_Log
//#undef	VU_COP2_LOG





/* COP 2 - VU */

#define		VU_STATUS_FLAG		16
#define		VU_MAC_FLAG			17	
#define		VU_CLIPPIN_FLAG		18
#define		VU_R_REGISTER		20
#define		VU_I_REGISTER		21
#define		VU_Q_REGISTER		22
#define		VU_P_REGISTER		23
#define		VU_TPC_REGISTER		26
#define		VU_CMSAR0_REGISTER	27
#define		VU_FBRST_REGISTER	28
#define		VU_VPU_STAT_RGISTER	29
#define		VU_CMSAR1_REGISTER	31




typedef struct	_VPU0 {

	_u32		CPR[32][4];				//VPU0	FloatingPoint Register for the CPU
    float		*CPR_p_float[32][4];	//VPU0	Pointer Float for conversion

	_u32		ACC[4];					//VPU0	
	float		*ACC_p_float[4];		//VPU0	

	_u32		CCR[32];				//VPU0	IntegerRegister	&
										// 		Control Register
	
	float		*CCR_p_float[32];	//VPU0	Pointer Float for conversion

	
	_u8			Mem[4096];
	_u8			MicroMem[4096];



	_u32		PC;
	_u8			halt;
	

}VPU0;




typedef struct	_VPU1 {

	_u32		CPR[32][4];				//VPU0	FloatingPoint Register for the CPU
    float		*CPR_p_float[32][4];	//VPU0	Pointer Float for conversion

	_u32		ACC[4];					//VPU0	
	float		*ACC_p_float[4];		//VPU0	

	_u32		CCR[32];				//VPU0	IntegerRegister	&
										// 		Control Register
	
	float		*CCR_p_float[32];	//VPU0	Pointer Float for conversion

	
	_u8			Mem[16384];
	_u8			MicroMem[16384];


	_u32		PC;
	_u8			halt;

}VPU1;



extern	VPU0	VectorUnit0;	//VU0 unit
extern	VPU1	VectorUnit1;	//VU0 unit


extern _u32	LowerOp;
extern _u32	UpperOp;

/* VU Main */
void	VU_init 	( void );



/* cop2 */
void 	VU_COP2_Log ( char * ftext  , ...   );
void 	DumpCop2Reg ( void );


/* cop2_flags */
float 	VectorUnit0_UPDATE_MAC_REG_X 	( double val );
float 	VectorUnit0_UPDATE_MAC_REG_Y 	( double val );
float 	VectorUnit0_UPDATE_MAC_REG_Z 	( double val );
float 	VectorUnit0_UPDATE_MAC_REG_W 	( double val );
void 	VectorUnit0_UPDATE_STAT_REG		( void );
void 	VectorUnit0_UPDATE_STAT_REG_DI	( void );
float 	VectorUnit1_UPDATE_MAC_REG_X 	( double val );
float 	VectorUnit1_UPDATE_MAC_REG_Y 	( double val );
float 	VectorUnit1_UPDATE_MAC_REG_Z 	( double val );
float 	VectorUnit1_UPDATE_MAC_REG_W 	( double val );
void 	VectorUnit1_UPDATE_STAT_REG		( void );
void 	VectorUnit1_UPDATE_STAT_REG_DI	( void );

/* VU0 Micromode */
void 	VectorUnit0_Execute_OneOpcode	( void );
void 	VU0_Execute						( void );


/* VU0 Micromode */
void 	VectorUnit1_Execute_OneOpcode	( void );
void 	VU1_Execute						( void );


/* VU micromode debug */
void 	PrintDebugVUopcodeUpper			( void );
void 	PrintDebugVUopcodeLower			( void );
void 	PrintDebugVUopcode				( void );


#endif








