/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include "VU0_micromode.h"



static void (*COP2_MI_VU0_UPPER[64])(void) = {

VU0_ADDbc,	VU0_ADDbc,	VU0_ADDbc,	VU0_ADDbc, 	VU0_SUBbc,	VU0_SUBbc,	VU0_SUBbc,	VU0_SUBbc,
VU0_MADDbc,	VU0_MADDbc,	VU0_MADDbc,	VU0_MADDbc, VU0_MSUBbc,	VU0_MSUBbc,	VU0_MSUBbc,	VU0_MSUBbc,

VU0_MAXbc,	VU0_MAXbc,	VU0_MAXbc,	VU0_MAXbc, 	VU0_MINIbc,	VU0_MINIbc,	VU0_MINIbc,	VU0_MINIbc,
VU0_MULbc,	VU0_MULbc,	VU0_MULbc,	VU0_MULbc, 	VU0_MULq, 	VU0_MAXi, 	VU0_MULi, 	VU0_MINIi,

VU0_ADDq, 	VU0_MADDq, 	VU0_ADDi, 	VU0_MADDi, 	VU0_SUBq, 	VU0_MSUBq, 	VU0_SUBi, 	VU0_MSUBi,
VU0_ADD, 	VU0_MADD, 	VU0_MUL, 	VU0_MAX, 	VU0_SUB, 	VU0_MSUB, 	VU0_OPMSUB, VU0_MINI,

VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI, 
VU0_COP2_MI_VU0_UPPER_T60, 						VU0_COP2_MI_VU0_UPPER_T61,	
VU0_COP2_MI_VU0_UPPER_T62,						VU0_COP2_MI_VU0_UPPER_T63


};




static void (*COP2_MI_VU0_UPPER_T60[32])(void) = {
VU0_ADDAbc,	VU0_SUBAbc,	VU0_MADDAbc,	VU0_MSUBAbc,	VU0_ITOF0,	VU0_FTOI0, 	VU0_MULAbc,	VU0_MULAq,
VU0_ADDAq, 	VU0_SUBAq, 	VU0_ADDA,		VU0_SUBBA, 		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI
};





static void (*COP2_MI_VU0_UPPER_T61[32])(void) = {
VU0_ADDAbc,	VU0_SUBAbc,	VU0_MADDAbc,	VU0_MSUBbc,	VU0_ITOF4,	VU0_FTOI4,	VU0_MULAbc,	VU0_ABS,
VU0_MADDAq,	VU0_MSUBAq,	VU0_MADDA,		VU0_MSUBA, 	VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI
};



static void (*COP2_MI_VU0_UPPER_T62[32])(void) = {
VU0_ADDAbc,	VU0_SUBAbc,	VU0_MADDAbc,	VU0_MSUBAbc,	VU0_ITOF12,	VU0_FTOI12,	VU0_MULAbc,	VU0_MULAi,
VU0_ADDAi,	VU0_SUBAi,	VU0_MULA,		VU0_OPMULA,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI
};



static void (*COP2_MI_VU0_UPPER_T63[32])(void) = {
VU0_ADDAbc,	VU0_SUBAbc,	VU0_MADDAbc,	VU0_MSUBAbc,	VU0_ITOF15,	VU0_FTOI15,	VU0_MULAbc,	VU0_CLIP,
VU0_MADDAi,	VU0_MSUBAi,	VU0_NI,			VU0_NOP,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI
};


static void (*COP2_MI_VU0_LOWER[128])(void) = {

VU0_LQ,		VU0_SQ,		VU0_NI,		VU0_NI,		VU0_ILW,		VU0_ISW,		VU0_NI,			VU0_NI,		
VU0_IADDIU,	VU0_ISUBIU,	VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_FCEQ,	VU0_FCSET,	VU0_FCAND,	VU0_FCOR,	VU0_FSEQ,		VU0_FSSET,		VU0_FSAND,		VU0_FSOR,
VU0_FMEQ,	VU0_NI,		VU0_FMAND,	VU0_FMOR,	VU0_FCGET,		VU0_NI,			VU0_NI,			VU0_NI,
VU0_B,		VU0_BAL,	VU0_NI,		VU0_NI,		VU0_JR,			VU0_JALR,		VU0_NI,			VU0_NI,
VU0_IBEQ,	VU0_IBNE,	VU0_NI,		VU0_NI,		VU0_IBLTZ,		VU0_IBGTZ,		VU0_IBLEZ,		VU0_IBGEZ,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_COP2_MI_VU0_LOWER_T64,VU0_NI,VU0_NI,VU0_NI,	VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI

};



static void (*COP2_MI_VU0_LOWER_T64[64])(void) = {
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,			VU0_NI,			VU0_NI,			VU0_NI,
VU0_IADD,	VU0_ISUB,	VU0_IADDI,	VU0_NI,		VU0_IAND,		VU0_IOR,		VU0_NI,			VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_COP2_MI_VU0_LOWER_T64_60,	VU0_COP2_MI_VU0_LOWER_T64_61,	VU0_COP2_MI_VU0_LOWER_T64_62,	VU0_COP2_MI_VU0_LOWER_T64_63


};



static void (*COP2_MI_VU0_LOWER_T64_60[32])(void) = {

VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_MOVE,	VU0_LQI,	VU0_DIV,	VU0_MTIR,
VU0_RNEXT,	VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_MFP,	VU0_XTOP,	VU0_XGKICK,	VU0_ESADD,	VU0_EATANxy,VU0_ESQRT,	VU0_ESIN


};





static void (*COP2_MI_VU0_LOWER_T64_61[32])(void) = {

VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_MR32,	VU0_SQI,	VU0_SQRT,	VU0_MFIR,
VU0_RGET,	VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_XITOP,	VU0_NI,		VU0_ERSADD,	VU0_EATANxz,VU0_ERSQRT,	VU0_EATAN



};




static void (*COP2_MI_VU0_LOWER_T64_62[32])(void) = {

VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_LQD,	VU0_RSQRT,	VU0_ILWR,
VU0_RINIT,	VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_ELENG,	VU0_ESUM,	VU0_ERCPR,	VU0_EEXP

};


static void (*COP2_MI_VU0_LOWER_T64_63[32])(void) = {

VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_SQD,	VU0_WAITQ,	VU0_ISWR,
VU0_RXOR,	VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,
VU0_NI,		VU0_NI,		VU0_NI,		VU0_NI,		VU0_ERLENG,	VU0_NI,		VU0_WAITP,	VU0_NI

};






