/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>

#include "nSX2.h"
 
#include "r5900_main.h"

#include "VU_opcodes.h"

#include "VU1_micromode_tables.h"

//#include "../PS2Edefs.h"

#include "VU.h"

/* for XTOP opcode */
#include "VIF.h"

#define		VU1GetLowerOp() *( (_u32 *) (( _u8 *)( VectorUnit1.MicroMem + VectorUnit1.PC ) ))
#define		VU1GetUpperOp() *( (_u32 *) (( _u8 *)( VectorUnit1.MicroMem + VectorUnit1.PC + 4 ) ))

_u8	debug_vu1 = 0; 
_u32	LowerOp;
_u32	UpperOp;




static VU1_MaxOpcode = 0;
 
  
void VectorUnit1_Execute_OneOpcode(void) {
 	char 		tempText[100];	

	_u32	TestOpcode;


		LowerOp = VU1GetLowerOp();
		UpperOp = VU1GetUpperOp();

		VectorUnit1.PC = VectorUnit1.PC + 8; 		

		if ( ((_u32)UpperOp & (_u32)0x40000000)) {
			VectorUnit1.halt = 1 ;
/*
			if(debug_vu1 == 1 ) {
				PrintToEmuOutput("2----NORMAL TERMINATION-----\n");
				sprintf(tempText,"VU1_PC:%4.4x:", VectorUnit1.PC - 8);PrintToEmuOutput(tempText);
			}
*/
		}

		
		if ( UpperOp & 0x80000000) { /* I flag */ 
	
			VectorUnit1.CCR[ VU_I_REGISTER ] = (_u32)LowerOp;

		} else {
			/* first upper */ 
			MipsCpu.vuOpcode = UpperOp;
			COP2_MI_VU1_UPPER[(MipsCpu.vuOpcode&0x3F) ]();	
			//if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);

			/* second lower */ 
			MipsCpu.vuOpcode = LowerOp;
			COP2_MI_VU1_LOWER[(MipsCpu.vuOpcode >> 25) & 0x7F]();
			//if(debug_vu1 == 1 ) PrintToEmuOutput(debugTempTextVU1);
		}
		
		/*Update the Number of Instructions*/
		MipsCpu.Nb_instructions++;		

 
		if ( VectorUnit1.PC > 0x3FF8 )  VectorUnit1.halt = 1 ;

}

/*
Execute a MicroProgram
*/      
void VU1_Execute( void ) {

	VU1_MaxOpcode = 0;

	while ( VectorUnit1.halt == 0 ) {  	VectorUnit1_Execute_OneOpcode(); }

	VectorUnit1_Execute_OneOpcode();
}


  
 
void VU1_NI(void){PrintDebugVUopcode();VectorUnit1.halt = 1;}



/********************************************************************************************/
/*							UPPER MICROCODE													*/
/********************************************************************************************/
		

void VU1_COP2_MI_VU1_UPPER_T60	(void){	COP2_MI_VU1_UPPER_T60[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU1_COP2_MI_VU1_UPPER_T61	(void){	COP2_MI_VU1_UPPER_T61[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU1_COP2_MI_VU1_UPPER_T62	(void){	COP2_MI_VU1_UPPER_T62[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
void VU1_COP2_MI_VU1_UPPER_T63	(void){	COP2_MI_VU1_UPPER_T63[(MipsCpu.vuOpcode & 0x7C0)>>6 ]();	}
	



void VU1_ABS	(void)	{	vuABS	(VectorUnit1);   }



void VU1_ADD	(void)	{	vuADD	(VectorUnit1);	}	
void VU1_ADDi	(void)	{	vuADDi	(VectorUnit1);	}	
void VU1_ADDq	(void)	{	vuADDq	(VectorUnit1);	}	
void VU1_ADDbc	(void)	{	vuADDbc	(VectorUnit1);	}


void VU1_ADDA	(void)	{	vuADDA	(VectorUnit1);	}
void VU1_ADDAq	(void)	{	vuADDAq	(VectorUnit1);	}
void VU1_ADDAi	(void)	{	vuADDAi	(VectorUnit1);	}
void VU1_ADDAbc	(void)	{	vuADDAbc(VectorUnit1);	}


void VU1_CLIP	(void)	{	vuCLIP	(VectorUnit1);	}

	
void VU1_FTOI0	(void)	{	vuFTOI0	(VectorUnit1);	}
void VU1_FTOI4	(void)	{	vuFTOI4	(VectorUnit1);	}
void VU1_FTOI12	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_FTOI15	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	 


void VU1_ITOF0	(void)	{	vuITOF0	(VectorUnit1);	}
void VU1_ITOF4	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ITOF12	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	
void VU1_ITOF15	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	


			
void VU1_MADD	(void)	{	vuMADD	(VectorUnit1);	}	
void VU1_MADDi	(void)	{	vuMADDi	(VectorUnit1);	}	
void VU1_MADDq	(void)	{	vuMADDq	(VectorUnit1);	}
void VU1_MADDbc	(void)	{	vuMADDbc(VectorUnit1);	}

	
void VU1_MADDA	(void)	{	vuMADDA	(VectorUnit1);	}
void VU1_MADDAi	(void)	{	vuMADDAi(VectorUnit1);	}
void VU1_MADDAq	(void)	{	vuMADDAq(VectorUnit1);	}
void VU1_MADDAbc(void)	{ 	vuMADDAbc(VectorUnit1);  }	



void VU1_MAX	(void)	{	vuMAX	(VectorUnit1);	}
void VU1_MAXi	(void)	{	vuMAXi	(VectorUnit1);	}			
void VU1_MAXbc	(void)	{	vuMAXbc	(VectorUnit1);	}	

void VU1_MINI	(void)	{	vuMINI	(VectorUnit1);	}
void VU1_MINIi	(void)	{	vuMINIi	(VectorUnit1);	}	
void VU1_MINIbc	(void)	{	vuMINIbc(VectorUnit1);	}


void VU1_MSUB	(void)	{	vuMSUB	(VectorUnit1);	}
void VU1_MSUBi	(void)	{	vuMSUBi	(VectorUnit1);	}
void VU1_MSUBq	(void)	{	vuMSUBq	(VectorUnit1);	}
void VU1_MSUBbc	(void)	{	vuMSUBbc(VectorUnit1);  }

		
void VU1_MSUBA	(void)	{	vuMSUBA	(VectorUnit1);	}
void VU1_MSUBAi	(void)	{	vuMSUBAi(VectorUnit1);	}
void VU1_MSUBAq	(void)	{	vuMSUBAq(VectorUnit1);	}
void VU1_MSUBAbc(void)	{	vuMSUBAbc(VectorUnit1);	}



void VU1_MUL	(void)	{	vuMUL	(VectorUnit1);	}
void VU1_MULi	(void)	{	vuMULi	(VectorUnit1);	}	
void VU1_MULq	(void)	{	vuMULq	(VectorUnit1);	}
void VU1_MULbc	(void)	{	vuMULbc	(VectorUnit1);	}
		
	
void VU1_MULA	(void)	{	vuMULA	(VectorUnit1);	}		
void VU1_MULAi	(void)	{	vuMULAi	(VectorUnit1);	}	
void VU1_MULAq	(void)	{	vuMULAq	(VectorUnit1);	}	
void VU1_MULAbc	(void)	{	vuMULAbc(VectorUnit1);	}	


void VU1_NOP	(void)	{	vuNOP	(VectorUnit1);	}


void VU1_OPMULA	(void)	{	vuOPMULA(VectorUnit1);	}
void VU1_OPMSUB	(void)	{	vuOPMSUB(VectorUnit1);	}



void VU1_SUB	(void)	{	vuSUB	(VectorUnit1);	}	
void VU1_SUBi	(void)	{	vuSUBi	(VectorUnit1);	}	
void VU1_SUBq	(void)	{	vuSUBq	(VectorUnit1);	}			
void VU1_SUBbc	(void)	{	vuSUBbc	(VectorUnit1);	}			



void VU1_SUBBA	(void)	{	vuSUBA	(VectorUnit1); 	}
void VU1_SUBAi	(void)	{	vuSUBAi	(VectorUnit1);	}
void VU1_SUBAq	(void)	{	vuSUBAq	(VectorUnit1);	} 
void VU1_SUBAbc	(void)	{	vuSUBAbc(VectorUnit1);	} 		
	


/********************************************************************************************/
/*							LOWER MICROCODE													*/
/********************************************************************************************/


void VU1_COP2_MI_VU1_LOWER_T64_60(void){COP2_MI_VU1_LOWER_T64_60[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU1_COP2_MI_VU1_LOWER_T64_61(void){COP2_MI_VU1_LOWER_T64_61[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU1_COP2_MI_VU1_LOWER_T64_62(void){COP2_MI_VU1_LOWER_T64_62[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU1_COP2_MI_VU1_LOWER_T64_63(void){COP2_MI_VU1_LOWER_T64_63[(MipsCpu.vuOpcode & 0x7C0)>>6]();}
void VU1_COP2_MI_VU1_LOWER_T64	 (void){COP2_MI_VU1_LOWER_T64[(MipsCpu.vuOpcode & 0x3F)]();}



void VU1_B		(void)	{	vuB		(VectorUnit1);	}		
void VU1_BAL	(void)	{	vuBAL	(VectorUnit1);	}

 
void VU1_DIV	(void)	{	vuDIV	(VectorUnit1);	}


void VU1_EATAN	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_EATANxy(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_EATANxz(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}


void VU1_EEXP	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ELENG	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}

void VU1_ERCPR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ERLENG	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ERSADD	(void)	{	vuERSADD(VectorUnit1); }
void VU1_ERSQRT	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}


void VU1_ESADD	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	
void VU1_ESIN	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ESQRT	(void)	{	vuESQRT	(VectorUnit1);	}
void VU1_ESUM	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	



void VU1_FCAND	(void)	{	vuFCAND	(VectorUnit1);	}	
void VU1_FCEQ	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}		
void VU1_FCGET	(void)	{	vuFCGET	(VectorUnit1);	}	
void VU1_FCOR	(void)	{	vuFCOR	(VectorUnit1);	}
void VU1_FCSET	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	



void VU1_FMAND	(void)	{	vuFMAND	(VectorUnit1);  }	
void VU1_FMEQ	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	
void VU1_FMOR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_FSAND	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}



void VU1_FSEQ	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_FSOR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_FSSET	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
		
	
 

void VU1_IADD	(void)	{	vuIADD	(VectorUnit1); 	}
void VU1_IADDI	(void)	{	vuIADDI	(VectorUnit1);	}
void VU1_IADDIU	(void)	{	vuIADDIU(VectorUnit1);	}
void VU1_IAND	(void)	{	vuIAND	(VectorUnit1);	}



void VU1_IBEQ	(void)	{	vuIBEQ	(VectorUnit1);	}
void VU1_IBGEZ	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_IBGTZ	(void)	{	vuIBGTZ	(VectorUnit1);	}
void VU1_IBLEZ	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_IBLTZ	(void)	{	vuIBLTZ	(VectorUnit1);	}	
void VU1_IBNE	(void)	{	vuIBNE	(VectorUnit1);	}	



void VU1_ILW	(void)	{	vuILW	(VectorUnit1);	}
void VU1_ILWR	(void)	{	vuILWR	(VectorUnit1);	}
void VU1_IOR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_ISW	(void)	{	vuISW	(VectorUnit1);	}
void VU1_ISUB	(void)	{	vuISUB	(VectorUnit1);	}
void VU1_ISUBIU	(void)	{   vuISUBIU(VectorUnit1);	}
void VU1_ISWR	(void)	{	vuISWR	(VectorUnit1);	}	


 
void VU1_JALR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_JR		(void)	{	vuJR	(VectorUnit1);  }		


void VU1_LQ		(void)	{	vuLQ	(VectorUnit1);	}
void VU1_LQD	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_LQI	(void)	{	vuLQI	(VectorUnit1);	}	
	

void VU1_MFIR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_MFP	(void)	{	vuMFP	(VectorUnit1);	}
void VU1_MOVE	(void)	{	vuMOVE	(VectorUnit1);	}
void VU1_MR32	(void)	{	vuMR32	(VectorUnit1);	}
void VU1_MTIR	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}



void VU1_RGET	(void)	{	vuRGET	(VectorUnit1);  }
void VU1_RINIT	(void)	{	vuRINIT	(VectorUnit1);  }
void VU1_RNEXT	(void)	{	vuRNEXT (VectorUnit1);  }
void VU1_RSQRT	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}
void VU1_RXOR	(void)	{	vuRXOR	(VectorUnit1);  }


void VU1_SQ		(void)	{	vuSQ	(VectorUnit1);	}
void VU1_SQD	(void)	{	vuSQD	(VectorUnit1);	}
void VU1_SQI	(void)	{	vuSQI	(VectorUnit1);	}
void VU1_SQRT	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}	
	
	
void VU1_WAITQ	(void)	{	vuWAITQ	(VectorUnit1);	}
void VU1_WAITP	(void)	{	vuWAITQ	(VectorUnit1);	}



void VU1_XITOP	(void)	{	PrintDebugVUopcode();VectorUnit1.halt = 1;}


/* Only with VectorUnit1 */
	
void VU1_XTOP	(void)	{	
	_u128 temp128;
	MipsMemoryReadW ( SpecialAreaMemory, &temp128 , VIF1_TOP_REG & 0xFFFF );
	VectorUnit1.CCR[ CURRENT_VU_IT ] = (_u16)temp128.lo ;
	if(debug_vu1 == 1 ) sprintf(debugTempTextVU1,"VI[%d] = %8.8lx.\n", CURRENT_VU_IT ,VectorUnit1.CCR[ CURRENT_VU_IT ] );
 }	


void VU1_XGKICK	(void)	{

	GIF_PATH1_Transfert((_u32*)(VectorUnit1.Mem + VectorUnit1.CCR[ CURRENT_VU_IS ] * 16));


}



