/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
static void (*cop2_opc[32])(void) = {
	NI, 	cop2_QMFC2, cop2_CFC2, 	NI, 		NI, 		cop2_QMTC2, cop2_CTC2, 	NI,		
	cop2_BC, 	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc,		
	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc, 	cop2_Vopc		

};

static char * debug_pcop2_opc[32] = {
	"NI", 	"QMFC2", 	"CFC2", "NI", 	"NI", 	"QMTC2", 	"CTC2", 	"NI",		
	"BC", 		"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI", 		"NI",		
	"cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc", "cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc",		
	"cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc", "cop2_Vopc", "cop2_Vopc", 	"cop2_Vopc", 	"cop2_Vopc"		

};

static void (*cop2_BC2_opc[32])(void) = {
BC2F, BC2T, BC2FL, BC2TL, NI, NI, NI, NI,
NI, NI, NI, NI, NI, NI, NI, NI,
NI, NI, NI, NI, NI, NI, NI, NI,
NI, NI, NI, NI, NI, NI, NI, NI
};


static void (*cop2_V_opc[64])(void) = {

	VADDbc,		VADDbc,		VADDbc,		VADDbc,		VSUBbc,		VSUBbc,		VSUBbc,		VSUBbc,
	VMADDbc,	VMADDbc,	VMADDbc,	VMADDbc,	VMSUBbc,	VMSUBbc,	VMSUBbc,	VMSUBbc,

	VMAXbc,		VMAXbc,		VMAXbc,		VMAXbc,		VMINIbc,	VMINIbc,	VMINIbc,	VMINIbc,
	VMULbc,		VMULbc,		VMULbc,		VMULbc,		VMULq,		VMAXi,		VMULi,		VMINIi,

	VADDq,		VMADDq,		VADDi,		VMADDi,		VSUBq,		VMSUBq,		VSUBi,		VMSUBi,
	VADD,		VMADD,		VMUL,		VMAX,		VSUB,		VMSUB,		VOPMSUB,	VMINI,

	VIADD,		VISUB,		VIADDI,		NI,			VIAND,		VIOR,		NI,			NI,
	VCALLMS,	VCALLMSR,	NI,			NI,			Vopc_t60,	Vopc_t61,	Vopc_t62,	Vopc_t63

};

static char * debug_pcop2_V_opc[64] = {
	"VADDbc",	"VADDbc",	"VADDbc",	"VADDbc",	"VSUBbc",	"VSUBbc",	"VSUBbc",	"VSUBbc",
	"VMADDbc",	"VMADDbc",	"VMADDbc",	"VMADDbc",	"VMSUBbc",	"VMSUBbc",	"VMSUBbc",	"VMSUBbc",

	"VMAXbc",	"VMAXbc",	"VMAXbc",	"VMAXbc",	"VMINIbc",	"VMINIbc",	"VMINIbc",	"VMINIbc",
	"VMULbc",	"VMULbc",	"VMULbc",	"VMULbc",	"VMULq",	"VMAXi",	"VMULi",	"VMINIi",

	"VADDq",	"VMADDq",	"VADDi",	"VMADDi",	"VSUBq",	"VMSUBq",	"VSUBi",	"VMSUBi",
	"VADD",		"VMADD",	"VMUL",		"VMAX",		"VSUB",		"VMSUB",	"VOPMSUB",	"VMINI",

	"VIADD",	"VISUB",	"VIADDI",	"NI",		"VIAND",	"VIOR",		"NI",		"NI",
	"VCALLMS",	"VCALLMSR",	"NI",		"NI",		"Vopc_t60",	"Vopc_t61",	"Vopc_t62",	"Vopc_t63"

};


static void (*cop2_V_t60_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF0,		VFTOI0,		VMULAbc,	VMULAq,
	VADDAq,		VSUBAq,		VADDA,		VSUBA,		VMOVE,		VLQI,		VDIV,		VMTIR,
	VRNEXT,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};

static char * debug_cop2_V_t60_opc[32] = {
	
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF0",	"VFTOI0",	"VMULAbc",	"VMULAq",
	"VADDAq",	"VSUBAq",	"VADDA",	"VSUBA",	"VMOVE",	"VLQI",		"VDIV",		"VMTIR",
	"VRNEXT",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		
	

};


static void (*cop2_V_t61_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF4,		VFTOI4,		VMULAbc,	VABS,
	VMADDAq,	VMSUBAq,	VMADDA,		VMSUBA,		VMR32,		VSQI,		VSQRT,		VMFIR, 
	VRGET,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};

static char * debug_cop2_V_t61_opc[32] = {
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"pMSUBAbc",	"VITOF4",	"VFTOI4",	"VMULAbc",	"VABS",
	"VMADDAq",	"VMSUBAq",	"VMADDA",	"VMSUBA",	"VMR32",	"VSQI",		"VSQRT",	"VMFIR",
	"VRGET",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		
		

};

static void (*cop2_V_t62_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF12,	VFTOI12,	VMULAbc,	VMULAi,
	VADDAi,		VSUBAi,		VMULA,		VOPMULA,	NI,			VLQD,		VRSQRT,		VILWR,
	VRINIT,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		



};

static char * debug_cop2_V_t62_opc[32] = {

	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF12",	"VFTOI12",	"VMULAbc",	"VMULAi",
	"VADDAi",	"VSUBAi",	"VMULA",	"VOPMULA",	"NI",		"VLQD",		"VRSQRT",	"VILWR",
	"VRINIT",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		



};


static void (*cop2_V_t63_opc[32])(void) = {

	VADDAbc,	VSUBAbc,	VMADDAbc,	VMSUBAbc,	VITOF15,	VFTOI15,	VMULAbc,	VCLIP,
	VMADDAi,	VMSUBAi,	NI,			VNOP,		NI,			VSQD,		VWAITQ,		VISWR,
	VRXOR,		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI		

};


static char * debug_cop2_V_t63_opc[32] = {
	"VADDAbc",	"VSUBAbc",	"VMADDAbc",	"VMSUBAbc",	"VITOF15",	"VFTOI15",	"VMULAbc",	"VCLIP",
	"VMADDAi",	"VMSUBAi",	"NI",		"VNOP",		"NI",		"VSQD",		"VWAITQ",		"VISWR",
	"VRXOR",	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI",		
	"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI", 		"pNI"		

};

/************************************************************************************************/



