//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include <stdio.h>
#include <stdlib.h>

#include "FormMainwindow.h"
#include "Deci2.h"
#include "Ttpy.h"
#include "Dbgp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainWindow *MainWindow;

BOOL		ClientIsConnected = FALSE;

//---------------------------------------------------------------------------
__fastcall TMainWindow::TMainWindow(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::FormCreate(TObject *Sender)
{
        StatBar->SimpleText = "Listening on port : " + IntToStr(SrvSock->Port);
        TcpBuffLength = 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::SrvSockAccept(TObject *Sender,
      TCustomWinSocket *Socket)
{
        RDEBUG_LOG("Connexion Client %s:%d",Socket->RemoteAddress,Socket->RemotePort);
		StatBar->SimpleText = "Connected";
        ClientIsConnected = TRUE;

}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::SrvSockClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
       //RDEBUG_LOG("End Connexion Client %s:%d",Socket->RemoteAddress,Socket->RemotePort);
       StatBar->SimpleText = "Disconnected";
       ClientIsConnected = FALSE;
}

void __fastcall TMainWindow::ClearLog1Click(TObject *Sender)
{
	MainWindow->Memo->Lines->Clear();


}
//---------------------------------------------------------------------------
void __fastcall TMainWindow::Savetoremotetxt1Click(TObject *Sender)
{
    MainWindow->Memo->Lines->SaveToFile("./remote_debuger.txt");
}
//---------------------------------------------------------------------------


/*****************************************************************************/

char *IntroMessage = \
" ----------------------------------------\n\
|    neutrinoSX2 Remote Debug v0.01      |\n\
|                                        |\n\
|  Thanks to Florin for this Great Idea  |\n\
 ----------------------------------------\n";



/******************************************************************************/


void __fastcall TMainWindow::SrvSockClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
	ClientSocket = Socket;
	SendPacket_TttpyMessage(IntroMessage);
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TMainWindow::SrvSockClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{

	sceDeci2Hdr * Deci2Hdr;
	int     Tcp_Length;



	ClientSocket = Socket;

    /* Copy received data to a tcp buffer */
    Tcp_Length =     Socket->ReceiveBuf(TcpBuf, BUFFER_SIZE );

	if( Tcp_Length < BUFFER_SIZE ) {


        /* 	if the tcp buffer is empty ,
        	it's the first tcp packet received of the Deci2 Message
        */
		if ( TcpBuffLength == 0 ) {
            /* Read the Deci Header to get the Deci2 length */
        	Deci2Hdr = (sceDeci2Hdr *)TcpBuf ;
            Deci2Size = Deci2Hdr->len;
            memset(InBuf, 0, BUFFER_SIZE);
            //RDEBUG_LOG("Deci2Size:" + IntToStr(Deci2Size));
		}

       //RDEBUG_LOG("TcpBuffLength:" + IntToStr(TcpBuffLength));

        /* 	if the previous received data and the current received
        	data is greater or equal than the Deci2 length

        */
		if ( ( TcpBuffLength + Tcp_Length ) >= Deci2Size ) {




			if ( ( TcpBuffLength + Tcp_Length ) == Deci2Size ) {
            /* I received all the current Deci2 Message

              <-----------All received data--------->
tcp buffer     ______________________________________
              |______________|_______________________|
              <TcpBuffLength> <-----Tcp_Length------>^	Deci2 Message length

			*/

            	/*	Copy the entire tcp buffer to the Input buffer */
            	memcpy( (char*)InBuf + TcpBuffLength,
                		(char*)TcpBuf,
                        Tcp_Length);

				InBuf_Lenght = TcpBuffLength + Tcp_Length;

 	          	Decode_Deci2();
                TcpBuffLength = 0;


             } else {
             /*	I received more than the Deci2 Message

              <---------------All received data-------------->
tcp buffer     ______________________________________ ________
              |______________|_______________________|________|
              <TcpBuffLength> <-----------Tcp_Length---------->
                                                     ^
              										 |Deci2 Message length
			*/
             	memcpy( (char*)InBuf + TcpBuffLength,
                		(char*)TcpBuf,
                        Tcp_Length);

             	InBuf_Lenght = TcpBuffLength + Tcp_Length;

                Decode_Deci2();

                /*  Second,
                	Copy the
                */

/*
                TcpBuffLength = TcpBuffLength + Tcp_Length;

                memcpy( (char*)InBuf ,
                		(char*)TcpBuf + Deci2Size,
                        Tcp_Length);

                InBuf_Lenght = TcpBuffLength -  Deci2Size;
                DumpReceiveData();
                Decode_Deci2();
*/
                TcpBuffLength = 0;


             }
                        
		} else {
        	/* I didn't received the entire Deci2 Message
              <-----All received data----->
tcp buffer     ______________________________________
              |______________|_____________|__________|
              <TcpBuffLength> <Tcp_Length > 		  ^	Deci2 Message length

            */

            /*	Copy the current packet behind the previous
            	received packets
            */
        	memcpy( (char*)(InBuf) + TcpBuffLength,
            		(char*)TcpBuf,
                    Tcp_Length);

			TcpBuffLength = TcpBuffLength + Tcp_Length;
        }

	} else {
        RDEBUG_LOG("Receive Buffer Out of Memory");
	}
}
//---------------------------------------------------------------------------

#include <stdlib.h>
#include <stdio.h>

void	DumpReceiveData() {
	long	Nb32bits;
	__int32 * p32b;
	char tString[1024];
	int boucle;

 	MainWindow->BinaryView->Lines->Add("-------------------");


    Nb32bits = OutBuf_Lenght / 4;

    for ( boucle = 0 ; boucle <  Nb32bits ; boucle ++ ) {
       p32b = (( ( __int32 *)OutBuf ) + boucle );
       sprintf(tString,"[%4.4d] %8.8x",boucle*4,(*p32b));
       MainWindow->BinaryView->Lines->Add(tString);

	}

}

void RDEBUG_Log ( char * ftext  , ...   ) {
	char LogText[ 1024 ];
    char LogText2[ 1024 ];

    va_list ap;
   	va_start (ap, ftext);
   	vsprintf (LogText, ftext, ap);
   	va_end (ap);

  	sprintf(LogText2,"[R_DBG]%s",LogText);

    MainWindow->Memo->Lines->Add( AnsiString(LogText2).c_str() );

}



void __fastcall TMainWindow::FormDestroy(TObject *Sender)
{

    if ( ClientIsConnected == TRUE ) {

   			ShowMessage("Disconnect from the Emulator first !\n Click OK when Done");
			SendPacket_Dbgp_EndProgram();
			ClientSocket->Close();
			ClientIsConnected = FALSE;
	}


    MainWindow->Memo->Lines->SaveToFile("./remote_debuger.txt");
	SrvSock->Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainWindow::SrvSockThreadEnd(TObject *Sender,
      TServerClientThread *Thread)
{
	MessageBox (0, "Hello World from DLL!\n", "Hi", MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

