/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "Common.h"
#include "CDVDisodrv.h"
#include "Misc.h"

#include "Loader_elf.h"

/* MUAD */
//#include "VU0.h"
//#include "VUmicro.h"
//#ifdef __WIN32__
//#include "RDebug/deci2.h"
//#endif

/*	MUAD
char *LabelAuthors = { N_(
	"PCSX2 a ps2 emulator\n\n"
	"written by:\n"
	"linuzappz, shadow, florin,\n"
	"alexey silinov, asadr, goldfinger\n"
	"\n"
	"Webmaster: Thorgal")
};

char *LabelGreets = { N_(
	"Greets to: Bobbi, Keith\n"
	"Special thanks to: Sjeep, Dreamtime, F|RES, BGnome, MrBrown\n"
	"Credits: Hiryu && Sjeep for their libcdvd (iso parsing and filesystem driver code)")
};
*/
/*	MUAD
static struct {
	char	*name;
	u32		size;
} ioprps[]={
	{"IOPRP15",    82741},
	{"IOPRP151",   82917},
	{"IOPRP153",   82949},
	{"IOPRP16",    91909},
	{"IOPRP165",   98901},
	{"IOPRP20",   109809},
	{"IOPRP202",  110993},
	{"IOPRP205",  119797},
	{"IOPRP21",   126857},
	{"IOPRP211",  129577},
	{"IOPRP213",  129577},
	{"IOPRP214",  140945},
	{"IOPRP22",   199257},
	{"IOPRP221",  196937},
	{"IOPRP222",  198233},
	{"IOPRP224",  201065},
	{"IOPRP23",   230329},
	{"IOPRP234",  247641},
	{"IOPRP24",   251065},
	{"IOPRP241",  251049},
	{"IOPRP242",  252409},
	{"IOPRP243",  253201},
	{"IOPRP252",  265233},
	{"IOPRP254",  264449},
	{"IOPRP255",  264449},
	{NULL,             0}
};

void GetRPCVersion(char *ioprp, char *rpcver){
	char	*p=ioprp; int i;
	struct TocEntry te;
	
	if (p && (CDVD_findfile(p+strlen("cdromN:"), &te) != -1)){
		for (i=0; ioprps[i].size>0; i++)
			if (te.fileSize==ioprps[i].size)
				break;
			if (ioprps[i].size>0)
				p=ioprps[i].name;
	}
	if (p && (p=strstr(p, "IOPRP")+strlen("IOPRP"))){
		for (i=0;(i<4) && p && (*p>='0') && (*p<='9');i++, p++)	rpcver[i]=*p;
		for (   ; i<4								 ;i++     ) rpcver[i]='0';
	}
}
*/
// LOAD STUFF
/*
#define ISODCL(from, to) (to - from + 1)

struct iso_directory_record {
	char length			[ISODCL (1, 1)]; // 711 
	char ext_attr_length		[ISODCL (2, 2)]; // 711
	char extent			[ISODCL (3, 10)]; // 733 
	char size			[ISODCL (11, 18)]; // 733 
	char date			[ISODCL (19, 25)]; // 7 by 711 
	char flags			[ISODCL (26, 26)];
	char file_unit_size		[ISODCL (27, 27)]; // 711 
	char interleave			[ISODCL (28, 28)]; // 711 
	char volume_sequence_number	[ISODCL (29, 32)]; // 723 
	unsigned char name_len		[ISODCL (33, 33)]; // 711 
	char name			[1];
};

#define btoi(b)		((b)/16*10 + (b)%16)		// BCD to u_char 
#define itob(i)		((i)/10*16 + (i)%10)		// u_char to BCD 

void mmssdd( char *b, char *p )
 {
	int m, s, d;
#if defined(__DREAMCAST__)
	int block = (b[0]&0xff) | ((b[1]&0xff)<<8) | ((b[2]&0xff)<<16) | (b[3]<<24);
#else
	int block = *((int*)b);
#endif
	
	block += 150;
	m = block / 4500;			// minuten
	block = block - m * 4500;	// minuten rest
	s = block / 75;				// sekunden
	d = block - s * 75;			// sekunden rest
	
	m = ( ( m / 10 ) << 4 ) | m % 10;
	s = ( ( s / 10 ) << 4 ) | s % 10;
	d = ( ( d / 10 ) << 4 ) | d % 10;	
	
	p[0] = m;
	p[1] = s;
	p[2] = d;
}

#define incTime() \
	time->frame++; \
	if(time->frame == 75) { \
		time->frame = 0; \
		time->second++; \
		if (time->second == 60) { \
			time->second = 0; \
			time->minute++; \
		} \
	}

#define READTRACK() \
	if (CDVDreadTrack(time) == -1) return -1; \
	buf = CDVDgetBuffer() + 12; if (buf == NULL) return -1;

#define READMDIR() \
	READTRACK(); \
	memcpy(mdir, buf+12, 2048); \
 \
	incTime(); \
	READTRACK(); \
	memcpy(mdir+2048, buf+12, 2048);

int GetCdromFile(u8 *mdir, cdvdLoc *time, s8 *filename) {
	struct iso_directory_record *dir;
	u8 *buf;
	int i;

	i = 0;
	while (i < 4096) {
		dir = (struct iso_directory_record*) &mdir[i];
		if (dir->length[0] == 0) {
			return -1;
		}
		i += dir->length[0];

		if (dir->flags[0] & 0x2) { // it's a dir
			if (!strnicmp((char*)&dir->name[0], filename, dir->name_len[0])) {
				if (filename[dir->name_len[0]] != '\\') continue;
				
				filename+= dir->name_len[0] + 1;

				mmssdd(dir->extent, (char*)time);
				READMDIR();
				i = 0;
			}
		} else {
			if (!strnicmp((char*)&dir->name[0], filename, strlen(filename))) {
				mmssdd(dir->extent, (char*)time);
				break;
			}
		}
	}
	return 0;
}

*/


/*
int LoadCdrom() {
	struct iso_directory_record *dir;
	u8 *buf;
	u8 mdir[4096];
	s8 exename[256];
	cdvdLoc _time;
	cdvdLoc *time = &_time;
	int i;

	

	time->minute = 0; time->second = 2; time->frame = 0x10;

	READTRACK();

	// skip head and sub, and go to the root directory record
	dir = (struct iso_directory_record*) &buf[12+156]; 

	mmssdd(dir->extent, (char*)time);

	READMDIR();

	if (GetCdromFile(mdir, time, "SYSTEM.CNF;1") == -1) {
		if (GetCdromFile(mdir, time, "PSX.EXE;1") == -1) return -1;
		
		SysPrintf("PSX Exe");


		READTRACK();
	}
	else {
		READTRACK();

		sscanf((char*)buf+12, "BOOT = cdrom:\\%s", exename);
		if (GetCdromFile(mdir, time, exename) == -1) {
			sscanf((char*)buf+12, "BOOT = cdrom:%s", exename);
			if (GetCdromFile(mdir, time, exename) == -1) {
				char *ptr = strstr(buf+12, "cdrom:");
				for (i=0; i<32; i++) {
					if (ptr[i] == ' ') continue;
					if (ptr[i] == '\\') continue;
				}
				strcpy(exename, ptr);
				if (GetCdromFile(mdir, time, exename) == -1)
					return -1;
			}
		}

		READTRACK();
	}


	


/*
	memcpy(&tmpHead, buf+12, sizeof(EXE_HEADER));

	

	psxRegs.pc = tmpHead.pc0;
	psxRegs.GPR.n.gp = tmpHead.gp0;
	psxRegs.GPR.n.sp = tmpHead.s_addr; 
	if (psxRegs.GPR.n.sp == 0) psxRegs.GPR.n.sp = 0x801fff00;

	while (tmpHead.t_size) {
		incTime();
		READTRACK();

		memcpy((void *)PSXM(tmpHead.t_addr), buf+12, 2048);

		tmpHead.t_size -= 2048;
		tmpHead.t_addr += 2048;
	}
*/

/*
	return 0;
}
*/

/*
int CheckCdrom() {
	struct iso_directory_record *dir;
	u8 *buf;
	u8 mdir[4096];
	cdvdLoc _time;
	cdvdLoc *time = &_time;
	char exename[256];
	int i;

	time->minute = 0; time->second = 2; time->frame = 0x10;

	READTRACK();

	strncpy(CdromId, buf+52, 10);

	// skip head and sub, and go to the root directory record
	dir = (struct iso_directory_record*) &buf[12+156]; 

	mmssdd(dir->extent, (char*)time);

	READMDIR();

	if (GetCdromFile(mdir, time, "SYSTEM.CNF;1") != -1) {
		READTRACK();

		sscanf((char*)buf+12, "BOOT = cdrom:\\%s", exename);
		if (GetCdromFile(mdir, time, exename) == -1) {
			sscanf((char*)buf+12, "BOOT = cdrom:%s", exename);
			if (GetCdromFile(mdir, time, exename) == -1) {
				char *ptr = strstr(buf+12, "cdrom:");
				for (i=0; i<32; i++) {
					if (ptr[i] == ' ') continue;
					if (ptr[i] == '\\') continue;
				}
				strcpy(exename, ptr);
				if (GetCdromFile(mdir, time, exename) == -1)
					return 0;
			}
		}
	}

/*	if (Config.PsxAuto) { // autodetect system (pal or ntsc)
		if (strstr(exename, "ES") != NULL)
			Config.PsxType = 1; // pal
		else Config.PsxType = 0; // ntsc
	}*/

/*
	UpdateVSyncRate();


		

	return 0;
}

*/


int GetPS2ElfName(char *name){
	int		f;
	char	buffer[256];//if a file is longer...it should be shorter :D
	char	*pos;
	char exename[256];


	int fileSize;


	char * FileBuf;


	CDVDFS_init();

	if ((f=CDVDFS_open("SYSTEM.CNF;1", 1))<0) {
		SysPrintf("SYSTEM.CNF not found\n");

		ShowMessage("Error : SYSTEM.CNF not found or No ISO/CD Selected");

		return FALSE;//could not find; not a PS/PS2 cdvd
	}

	CDVDFS_read(f, buffer, 256);

	CDVDFS_close(f);

	SysPrintf("SYSTEM.CNF:\n",buffer);
	SysPrintf("%s\n",buffer);
	pos=strstr(buffer, "BOOT2")+strlen("BOOT2");

	if (pos==NULL) {
		ShowMessage("Error : BOOT2 param not found in SYSTEM.CNF.");
		
		return FALSE;
	}


	while (pos && *pos && pos<=&buffer[255] 
		&& (*pos<'A' || (*pos>'Z' && *pos<'a') || *pos>'z'))
		pos++;

	if (!pos || *pos==0) return FALSE;

	sscanf(pos, "%s", name);
//	SysPrintf("name: '%s'\n", name);

/*************************************************************/
	/* MUAD ADD */

	/* Get part after "cdrom:/" */
	strncpy( exename, name+8,strlen(name) - 8);
	SysPrintf("exename: '%s'\n", exename);


	/* Open the File */
	if ((f=CDVDFS_open(exename, 1))<0) {
		//SysPrintf("%s not found\n",exename);

		ShowMessage("Error : Elf file  not found on support.");

		return FALSE;//could not find; not a PS/PS2 cdvd
	}


	/* Get the File Size */
	fileSize = CDVDFS_lseek(f, 0, SEEK_END);
	CDVDFS_lseek(f, 0, SEEK_SET);


	/* Alloc a buffer and fill it with data file */
	FileBuf = (char * ) malloc( fileSize * sizeof(char));
	if ( FileBuf == NULL ) {
		ShowMessage("Error : Memory Allocation Error for Elf.");
		return FALSE;
	}
	CDVDFS_read(f,FileBuf , fileSize);	

	/* ELF */
	if ( (*((__int32 *)FileBuf+0)) == 0x464C457F ) {


		/* Decode Elf */
		ElfLoadHeader( FileBuf );
		CopyProgramToMemory( FileBuf ) ;
		CopySectionToMemory ( FileBuf ) ;
		ElfFreeHeader();

		SysPrintf("Start Adress : 0x%8.8lx",ElfStartAdress);
	} else {

		SysPrintf("Invalid Elf File : Header : 0x%8.8lx",(*((__int32 *)FileBuf+0)) );
	}


	/* Free Buffer */
	free( FileBuf );

	/* Close File */
	CDVDFS_close(f);


	return TRUE;
}




/*#define PSX_EXE     1
#define CPE_EXE     2
#define COFF_EXE    3
#define INVALID_EXE 4

static int PSXGetFileType(FILE *f) {
    unsigned long current;
    unsigned long mybuf[2048];
    EXE_HEADER *exe_hdr;
    FILHDR *coff_hdr;

    current = ftell(f);
    fseek(f,0L,SEEK_SET);
    fread(mybuf,2048,1,f);
    fseek(f,current,SEEK_SET);

    exe_hdr = (EXE_HEADER *)mybuf;
    if (memcmp(exe_hdr->id,"PS-X EXE",8)==0)
        return PSX_EXE;

    if (mybuf[0]=='C' && mybuf[1]=='P' && mybuf[2]=='E')
        return CPE_EXE;

    coff_hdr = (FILHDR *)mybuf;
    if (coff_hdr->f_magic == 0x0162)
        return COFF_EXE;

    return INVALID_EXE;
}

int Load(char *ExePath) {
	FILE *tmpFile;
	EXE_HEADER tmpHead;
	int type;

	strcpy(CdromId, "SLUS_999.99");

    tmpFile = fopen(ExePath,"rb");
	if (tmpFile == NULL) { SysMessage("Error opening file: %s", ExePath); return 0; }

    type = PSXGetFileType(tmpFile);
    switch (type) {
    	case PSX_EXE:
	        fread(&tmpHead,sizeof(EXE_HEADER),1,tmpFile);
		    fseek(tmpFile, 0x800, SEEK_SET);		
			fread((void *)PSXM(tmpHead.t_addr), tmpHead.t_size,1,tmpFile);
			fclose(tmpFile);
			psxRegs.pc = tmpHead.pc0;
			psxRegs.GPR.n.gp = tmpHead.gp0;
			psxRegs.GPR.n.sp = tmpHead.s_addr; 
			if (psxRegs.GPR.n.sp == 0) psxRegs.GPR.n.sp = 0x801fff00;
	        break;
    	case CPE_EXE:
    		SysMessage("Pcsx found that you wanna use a CPE file. CPE files not support yet");
			break;
    	case COFF_EXE:
    		SysMessage("Pcsx found that you wanna use a COFF file.COFF files not support yet");
			break;
    	case INVALID_EXE:
    		SysMessage("This file is not a psx file");
			break;
	}
	return 1;
}
*/

u16 logProtocol;
u8  logSource;
int connected=0;

void __Log(char *fmt, ...) {
#ifdef EMU_LOG
	va_list list;
	static char tmp[2024];	//hm, should be enough

	va_start(list, fmt);
#ifdef __WIN32__
	if (connected && logProtocol>=0 && logProtocol<0x10){
		vsprintf(tmp, fmt, list);
		sendTTYP(logProtocol, logSource, tmp);
	}//else	//!!!!! is disabled, so the text goes to ttyp AND log
#endif
	{
#ifndef LOG_STDOUT
		if (varLog & 0x80000000) {
			vsprintf(tmp, fmt, list);
			SysPrintf(tmp);
		} else {
			vfprintf(emuLog, fmt, list);
		}
#else	//i assume that this will not be used (Florin)
		vsprintf(tmp, fmt, list);
		SysPrintf(tmp);
#endif
	}
	va_end(list);
#endif
}

// STATES

int SaveState(char *file) {
/*
	gzFile f;
	//GSFreeze_t *gsfP;
	
	

    f = gzopen(file, "wb");
	if (f == NULL) return -1;




    gzwrite(f, psM, 0x02000000);         //32 MB main memory   
	//if (Config.HLE) psxBiosFreeze(1);  //now how you can do that? :)
	gzwrite(f, psR, 0x00400000);  //4 mb rom memory
    gzwrite(f, psS, 0x00004000);  // scratch pad 
	gzwrite(f, psH, 0x00010000);  //hardware memory

	gzwrite(f, (void*)&cpuRegs, sizeof(cpuRegs));//cpu regs + COP0
//    gzwrite(f, (void*)&fpuRegs, sizeof(fpuRegs));//fpu regs
//    gzwrite(f, (void*)&tlb, sizeof(tlb));//tlbs
//    gzwrite(f, (void*)&VU0, sizeof(VU0));//Vu0
    gzwrite(f, (void*)&VU1, sizeof(VU1));//Vu1
    gzwrite(f, (void*)&vif0Regs, sizeof(vif0Regs));//vif0
    gzwrite(f, (void*)&vif1Regs, sizeof(vif1Regs));//vif1
    //hope didn't forgot any cpu....
*/    


	// GS
	/*gsfP = (GSFreeze_t *) malloc(sizeof(GSFreeze_t));
	gsfP->ulFreezeVersion = 1;
	GS_freeze(1, gpufP);
	gzwrite(f, gpufP, sizeof(GSFreeze_t));
	free(gsfP);*/


	/*sioFreeze(f, 1);
	cdrFreeze(f, 1);
	psxHwFreeze(f, 1);
	psxRcntFreeze(f, 1);
	mdecFreeze(f, 1);*/

//	gzclose(f);

	return 0;
}

int LoadState(char *file) {
//	gzFile f;
//	GSFreeze_t *gsfP;
	

//	f = gzopen(file, "rb");
//	if (f == NULL) return -1;

//	Cpu->Reset();

	
  //  gzread(f, psM, 0x02000000);         //32 MB main memory   
//	gzread(f, psR, 0x00400000);  //4 mb rom memory
    //if (Config.HLE) psxBiosFreeze(0);  //now how you can do that? :)
  //  gzread(f, psS, 0x00004000);  // scratch pad 
//	gzread(f, psH, 0x00010000);  //hardware memory

//	gzread(f, (void*)&cpuRegs, sizeof(cpuRegs));//cpu regs + COP0
    //gzread(f, (void*)&fpuRegs, sizeof(fpuRegs));//fpu regs
    //gzread(f, (void*)&tlb, sizeof(tlb));//tlbs
    //gzread(f, (void*)&VU0, sizeof(VU0));//Vu0
    //gzread(f, (void*)&VU1, sizeof(VU1));//Vu1
    //gzread(f, (void*)&vif0Regs, sizeof(vif0Regs));//vif0
    //gzread(f, (void*)&vif1Regs, sizeof(vif1Regs));//vif1
    //hope didn't forgot any cpu....

	// gs
	/*gsfP = (GSFreeze_t *) malloc (sizeof(GSFreeze_t));
	gzread(f, gsfP, sizeof(GSFreeze_t));
	GS_freeze(0, gsfP);
	free(gsfP);*/

	

	/*sioFreeze(f, 0);
	cdrFreeze(f, 0);
	psxHwFreeze(f, 0);
	psxRcntFreeze(f, 0);
	mdecFreeze(f, 0);*/

//	gzclose(f);

	return 0;
}

/*	MUAD

typedef struct {
	char id[8];
	char name[64];
} LangDef;

LangDef sLangs[] = {
	{ "ar", N_("Arabic") },
	{ "ca", N_("Catalan") },
	{ "de", N_("German") },
	{ "el", N_("Greek") },
	{ "en", N_("English") },
	{ "es", N_("Spanish") },
	{ "fr", N_("French") },
	{ "it", N_("Italian") },
	{ "pt", N_("Portuguese") },
	{ "ro", N_("Romanian") },
	{ "ru", N_("Russian") },
	{ "", "" },
};


char *ParseLang(char *id) {
	int i=0;

	while (sLangs[i].id[0] != 0) {
		if (!strcmp(id, sLangs[i].id))
			return _(sLangs[i].name);
		i++;
	}

	return id;
}

*/