/*  Pcsx2 - Pc Ps2 Emulator
 *  Copyright (C) 2002-2003  Pcsx2 Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Rpc_services.h"

///////////////////////////////////////////////////0001
void SjPCM_Puts(char *format, ...){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Puts(\"%s\", ...)\n", format);
#endif
	SysPrintf("%s\n", format);//bonus: \n
}

///////////////////////////////////////////////////0002
int SjPCM_Init(int sync){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Init(%d)\n", sync);
#endif

	return 1;
}

///////////////////////////////////////////////////0003
void SjPCM_Play(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Play() DUMMY\n");
#endif
}

///////////////////////////////////////////////////0004
void SjPCM_Pause(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Pause() DUMMY\n");
#endif
}

///////////////////////////////////////////////////0005
void SjPCM_Setvol(unsigned int volume){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Setvol(0x%08X) DUMMY\n", volume);
#endif
}

///////////////////////////////////////////////////0006
void SjPCM_Enqueue(short *left, short *right, int size, int wait){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Enqueue(left=0x%08X, right=0x%08X, size=%d, wait=%d) DUMMY\n",
		left, right, size, wait);
#endif
}

///////////////////////////////////////////////////0007
void SjPCM_Clearbuff(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Clearbuff() DUMMY\n");
#endif
}

///////////////////////////////////////////////////0008
void SjPCM_Quit(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Quit() DUMMY\n");
#endif
}

///////////////////////////////////////////////////0009
int SjPCM_Available(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Available() DUMMY\n");
#endif
	return 0;
}

///////////////////////////////////////////////////000A
int SjPCM_Buffered(){
#ifdef RPC_LOG
	RPC_LOG("[RPC:sjpcm] SjPCM_Buffered() DUMMY\n");
#endif
	return 0;
}

//ENTRYPOINT
void sifcall_sjpcm(struct t_sif_rpc_call*	call, u32 *bin, u32 *bout){
	switch (call->rpc_number) {
//v1.0
	case SJPCM_PUTS:			SjPCM_Puts((char*)bin);	break;
	case SJPCM_INIT:	*bout=	SjPCM_Init(bin[0]);		break;
	case SJPCM_PLAY:			SjPCM_Play();			break;
	case SJPCM_PAUSE:			SjPCM_Pause();			break;
	case SJPCM_SETVOL:			SjPCM_Setvol(bin[0]);	break;
	case SJPCM_ENQUEUE:			SjPCM_Enqueue(
	(short*)bin[0], (short*)bin[1],	bin[2], bin[3]);	break;
	case SJPCM_CLEARBUFF:		SjPCM_Clearbuff();		break;
	case SJPCM_QUIT:			SjPCM_Quit();			break;
//v2.0
	case SJPCM_GETAVAIL:*bout=	SjPCM_Available();		break;
	case SJPCM_GETBUFFD:*bout=	SjPCM_Buffered();		break;
	default:
#ifdef RPC_LOG
		RPC_LOG("[RPC:sjpcm] <%d> function is not implemented (version 3.0?!?)\n", call->rpc_number);
#endif
		*bout=-1;	//general fail
	}
}
