/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>

#include <strings.h>
#include <float.h>
#include <math.h>


#include "nSX2.h"

#include "r5900_main.h"
 
#include "bios_syscalls.h"
#include "bios_syscalls_table.h"
 
#include "PS2Edefs.h"

#include "Sif.h"

/* I must declare a function to avoid this kind of include */
#include "DmaC.h"

/* must create function to avoid this kind of declaration */
#include "IntrC.h"


#include "GS.h"


SModuleBind nsx2SIFBindModule[SIF_PLUGGIN_MAX_BIND];


/**********************************************************************************************************
										SIF									
***********************************************************************************************************/

void SYSCALL_sceSifDmaStat( ) 	{ 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifDmaStat",(long)MipsCpu.PC );
#endif	
  
    
	MipsCpu.GPR[CPU_REG_V0].lo = -1;
	
	INCREMENT_PC();

	
}

SifClientData *scldat;
SifRpcCall	*srpccall;

/*
a0 : * SifDmaData : DMA contents
a1 : _u32 : len : sdd data count
*/
void SYSCALL_sceSifSetDma( ) 					{ 
	char temp_string[256];

   SifDmaData *sdd;
   _u32 sdd_adrr;
   _s32	sdd_data_count;
   
   SifCmdHdr *schdr;
   _u32 schdr_adrr;
   
   SifRpcBind *sbrpc;
   _u32	sbrpc_addr;
   

   _u32	scldat_addr;
  _u32	 srpccall_add ; 
  
  
   _u16	boucle;
   _u16	* ReadData  ;
  
  	_u32	SemaID;
	

	_u8		*RPC_Version_Addr;
	_u8		*RPC_Version_Addr2;

	_u64	RPC_In_addr;
	_u64	RPC_Out_addr;

	_u32	*RPC_In_addr_p;
	_u32	*RPC_Out_addr_p;
  	
 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifSetDma",(long)MipsCpu.PC );
#endif	
 
  	/*PCSX2 code : don't understand */
	sdd_data_count = (_s32)(MipsCpu.GPR[CPU_REG_A1].lo)  - 1;
 	if (sdd_data_count < 0) {
 		MipsCpu.PC = MipsCpu.PC + 4;
 		PrintToBIOSOutput (  "|data count < 0\n" );
   		return;
	}

 	sdd_adrr = (MipsCpu.GPR[CPU_REG_A0].lo & 0x01FFFFFF) +  sdd_data_count * sizeof(struct _SifDmaData) ;
 	sdd = (  SifDmaData * )	&MipsMemory [  sdd_adrr ];
/*
 	if ( debug_print_syscall == 1 )	{

		sprintf(temp_string,"|addr=%8.8lx, nb=%lx \n",(_u32)MipsCpu.GPR[CPU_REG_A0].lo, (_s32)sdd_data_count);PrintToBIOSOutput (  temp_string );
		PrintToBIOSOutput ( "|_SifDmaData\n" );
        sprintf(temp_string,"  |data:%8.8lx\n",sdd->data);PrintToBIOSOutput (  temp_string );
        sprintf(temp_string,"  |addr:%8.8lx\n",sdd->addr);PrintToBIOSOutput (  temp_string );
     	sprintf(temp_string,"  |size:%8.8lx\n",sdd->size);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"  |mode:%8.8lx\n",sdd->mode);PrintToBIOSOutput (  temp_string );
	
	}
*/	
  	if ( ( sdd->data == 0 ) || 	( sdd->addr == 0 ) ) {
	    MipsCpu.GPR[CPU_REG_V0].lo = 1 ;
		MipsCpu.PC = MipsCpu.PC + 4;
		return;
	}
	
	/*
	sdd->data : is address of data to be send
	Read the Header of Data to be send
	*/
	schdr_adrr  = sdd->data & 0x01FFFFFF;		
	schdr = (struct _SifCmdHdr*)&MipsMemory [  schdr_adrr ];	
/*
 	if ( debug_print_syscall == 1 )	{
	
	    PrintToBIOSOutput ( "  |_HeaderOfDataToSend(SifCmdHdr)\n" );
        sprintf(temp_string,"    |size:%8.8lx\n",schdr->size);PrintToBIOSOutput (  temp_string );
        sprintf(temp_string,"    |daddr:%8.8lx\n",schdr->daddr);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"    |fcode:%8.8lx\n",schdr->fcode);PrintToBIOSOutput (  temp_string );
    	sprintf(temp_string,"    |opt:%8.8lx\n",schdr->opt);PrintToBIOSOutput (  temp_string );
	}
*/

	/* fcode is the code number to call */

	switch( schdr->fcode ) {
		
		/*0x80000000*/
		case SIF_CMDC_CHANGE_SADDR: 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|CHANGE_SADDR",(long)MipsCpu.PC );
#endif	

/*
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_CHANGE_SADDR \n",Ps2Bios.PS2_Sched.RunningIDThread);PrintToEmuOutput (  temp_string );
}
*/


		break;
		
		/*0x80000001*/
		case SIF_CMDC_SET_SREG: 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|SET_SREG",(long)MipsCpu.PC );
#endif	

/*
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_SET_SREG \n",Ps2Bios.PS2_Sched.RunningIDThread);PrintToEmuOutput (  temp_string );
}
*/

		break;

		/*0x80000002*/
		case SIF_CMDC_INIT_CMD: 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|INIT_CMD",(long)MipsCpu.PC );
#endif	

/*
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_INIT_CMD \n",Ps2Bios.PS2_Sched.RunningIDThread);PrintToEmuOutput (  temp_string );
}
*/

		break;

		/*0x80000003*/
		case SIF_CMDC_RESET_CMD: 
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|RESET_CMD",(long)MipsCpu.PC );
#endif
/*
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_RESET_CMD \n",Ps2Bios.PS2_Sched.RunningIDThread);PrintToEmuOutput (  temp_string );
}
*/
			RPC_Version_Addr = ((_u8 *)&MipsMemory [  ( sdd->data  )& 0x01FFFFFF ])/* + 34*/ + 0x18  ;
			(*SIFSetRPCVersion)(strstr((char *)(RPC_Version_Addr), "cdrom") );
		break;



		/* Bind RPC */
		case 0x80000009: 
/*
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_BIND \n",Ps2Bios.PS2_Sched.RunningIDThread);PrintToEmuOutput (  temp_string );
}
*/

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|BIND",(long)MipsCpu.PC );
#endif


			/* Read the Bind Info */
			sbrpc_addr 	= sdd->data & 0x01FFFFFF;
			sbrpc 		= (struct _SifRpcBind*)&MipsMemory [  sbrpc_addr ];
/*			
			// Show  Bind Info
			if ( debug_print_syscall == 1 )	{
				PrintToBIOSOutput ( "    |BindRPC\n" );
				sprintf(temp_string,"    |rec_id:%8.8lx\n",sbrpc->rec_id);PrintToBIOSOutput (  temp_string );					
				sprintf(temp_string,"    |pkt_addr:%8.8lx\n",sbrpc->pkt_addr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |rpc_id:%8.8lx\n",sbrpc->rpc_id);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |client_addr:%8.8lx\n",sbrpc->client_addr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"    |rpc_number:%8.8lx\n",sbrpc->rpc_number);PrintToBIOSOutput (  temp_string );
			}
*/			
			/* Read the Client Info */
			scldat_addr = sbrpc->client_addr & 0x01FFFFFF;
			scldat		=(struct _SifClientData*)&MipsMemory [  scldat_addr ];
/*
			//Show Client Info 
			if ( debug_print_syscall == 1 )	{
				PrintToBIOSOutput ( "    |_ClientData\n" );
				sprintf(temp_string,"     |rpcdat.paddr:%8.8lx\n",scldat->rpcd.paddr);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.pid:%8.8lx\n",scldat->rpcd.pid);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.tid:%8.8lx\n",scldat->rpcd.tid);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |rpcdat.mode:%8.8lx\n",scldat->rpcd.mode);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |command:%8.8lx\n",scldat->command);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |buff:%8.8lx\n",scldat->buff);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |cbuff:%8.8lx\n",scldat->cbuff);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |func:%8.8lx\n",scldat->func);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |para_add:%8.8lx\n",scldat->para_add);PrintToBIOSOutput (  temp_string );
				sprintf(temp_string,"     |serve_add:%8.8lx\n",scldat->serve_add);PrintToBIOSOutput (  temp_string );
			}
*/			
			/* Update Current Semaphore */
			SemaID = scldat->rpcd.tid;
			if (SemaID == -1) {			//don't Try carshowroom without this 
				SemaID = 0;
				//scldat->rpcd.tid = 0;		//Muad testing
			}

			Ps2Bios.Sema[ SemaID ].sema->currentCount = Ps2Bios.Sema[ SemaID ].sema->currentCount - 1;
	
			/* Pass the RPC ID to Server */
			scldat->serve_add	= sbrpc->rpc_number;
			

		break;

		
		/* Call RPC */
		case 0x8000000a: 

			/* Read the Call Info */
			srpccall_add = sdd->data & 0x01FFFFFF;
			srpccall		=(struct _SifRpcCall*)&MipsMemory [  srpccall_add ];

			/* Read the Client Info */
			scldat_addr = srpccall->client_addr & 0x01FFFFFF;
			scldat		=(struct _SifClientData*)&MipsMemory [  scldat_addr ];
			
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|CALL",(long)MipsCpu.PC );
#endif

			/* Update the Semaphore */
			SemaID = scldat->rpcd.tid;
			if (SemaID == -1) {
				SemaID = 0;
				//scldat->rpcd.tid = 0;		//Muad testing
			}
				
			if ( Ps2Bios.Sema[ SemaID ].sema != NULL ) 
				Ps2Bios.Sema[ SemaID ].sema->currentCount = Ps2Bios.Sema[ SemaID ].sema->currentCount - 1;


 			/*PCSX2 : don't understand */
			sdd_data_count = (_s32)sdd_data_count  - 1;
 
			/* Get the Sif Dma Data pointer */
 			sdd_adrr = (MipsCpu.GPR[CPU_REG_A0].lo & 0x01FFFFFF) + ( sdd_data_count * sizeof(struct _SifDmaData) );
 			sdd = (  SifDmaData * )	&MipsMemory [  sdd_adrr ];

			/* Set In and Out Buffer Add */
			RPC_In_addr 	= sdd->data ;
			RPC_Out_addr	= srpccall->receive_add ;
/* 
			if ( debug_print_syscall == 1 ) { 
				sprintf(temp_string,"      |In Addr:%8.8lx\n",RPC_In_addr);PrintToBIOSOutput (  temp_string ); 
				sprintf(temp_string,"      |Out Addr:%8.8lx\n",RPC_Out_addr);PrintToBIOSOutput (  temp_string );
			}
*/
			RPC_In_addr_p = (_u32*)&MipsMemory [  RPC_In_addr & 0x01FFFFFF ];
			RPC_Out_addr_p = (_u32*)&MipsMemory [  RPC_Out_addr & 0x01FFFFFF ];
/*		
if ( debug_thread == 1 ) {
sprintf(temp_string,"(%d)[SIFRPC]SIF_CMDC_CALL ( 0x%8.8lx )\n",Ps2Bios.PS2_Sched.RunningIDThread,scldat->serve_add);PrintToEmuOutput (  temp_string );
sprintf(temp_string,"[SIFRPC]In Addr:%8.8lx\n",RPC_In_addr);PrintToEmuOutput (  temp_string ); 
sprintf(temp_string,"[SIFRPC]Out Addr:%8.8lx\n",RPC_Out_addr);PrintToEmuOutput (  temp_string );

}
*/
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]|Server_Add:0x%8.8lx",(long)MipsCpu.PC, scldat->serve_add);
	SYSCALL_LOG("%8.8lx:[BIOS]|In Addr   :0x%8.8lx",(long)MipsCpu.PC, RPC_In_addr);
	SYSCALL_LOG("%8.8lx:[BIOS]|Out Addr  :0x%8.8lx",(long)MipsCpu.PC, RPC_Out_addr);
#endif



			/* What is the Server ?*/
			switch ( scldat->serve_add ) {

				case 0:		break;	

				case PAD_BIND_RPC_ID1:	RPC_8000010f_PadMan1( srpccall->rpc_number, RPC_In_addr, RPC_Out_addr );				break;
				case 0x80000100:		RPC_80000100_XPadMan1( srpccall->rpc_number, RPC_In_addr, RPC_Out_addr ); break;


				case 0x80000001:	nsx2SIFBindModule[BIND_0x80000001].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000003:	nsx2SIFBindModule[BIND_0x80000003].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000400:	nsx2SIFBindModule[BIND_0x80000400].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000592:	nsx2SIFBindModule[BIND_0x80000592].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000593:	nsx2SIFBindModule[BIND_0x80000593].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000595:	nsx2SIFBindModule[BIND_0x80000595].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000596:	nsx2SIFBindModule[BIND_0x80000596].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000597:	nsx2SIFBindModule[BIND_0x80000597].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x8000059a:	nsx2SIFBindModule[BIND_0x8000059a].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000601:	nsx2SIFBindModule[BIND_0x80000601].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x80000006:	nsx2SIFBindModule[BIND_0x80000006].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case 0x8000011f:	nsx2SIFBindModule[BIND_0x8000011f].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
//				case 0x80000100:	nsx2SIFBindModule[BIND_0x80000100].pCallFunction(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				
	
				case 0x80000101:	nsx2SIFBindModule[BIND_0x80000101].pCallFunction	(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case AMIGAMOD_IRX:	nsx2SIFBindModule[BIND_AMIGAMOD_IRX].pCallFunction	(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case SJPCM_IRX:		nsx2SIFBindModule[BIND_SJPCM_IRX].pCallFunction		(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case RPC_NPM_USER:	nsx2SIFBindModule[BIND_RPC_NPM_USER].pCallFunction	(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;
				case CDVD_IRX:		nsx2SIFBindModule[BIND_CDVD_IRX].pCallFunction		(srpccall , RPC_In_addr_p, RPC_Out_addr_p ); break;

				

				default: 	
#ifdef EMU_LOG
	EMU_LOG("SIF RPC serve_add:0x%8.8lx Unknown\n",scldat->serve_add);
#endif
					RPC_Out_addr_p[0] = 1;

				}

			if (srpccall->has_async_ef && scldat->func){
				MipsCpu.GPR[CPU_REG_A0].lo = (u32)scldat->para_add;
//				BIOS_ExecHandler((_u32)scldat->func) ;

 INTC_ExecSubFunc( 	(_u32)scldat->func ,
							INTC_SUBF_SAVE_REG | INTC_SUBF_SET_A0 , 
							(u32)scldat->para_add , 0, 0);				


			}


		break;


		default: 
#ifdef EMU_LOG
	EMU_LOG("     |fcode:%8.8lx is unknown\n",schdr->fcode);
#endif

	
		 break;
	}


	INTC_RaiseIntByDMA ( DMA_CH5 );

	/* Every thing OK */ 
    MipsCpu.GPR[CPU_REG_V0].lo = 1 ;



	MipsCpu.PC = MipsCpu.PC + 4;
} 


/*
isceSifSetDChain

//[module]	KERNEL
//[made by]	[RO]man & others (october 2002)

	int var_10;

	KSEG1_ADDR(D5_CHCR)	= 0;
	KSEG1_ADDR(D5_QWC)	= 0;
	KSEG1_ADDR(D5_CHCR)	= 0x184;	// 0001 1000 0100
	var_10	= KSEG1_ADDR(D5_CHCR);		// ?!?


*/



void SYSCALL_sceSifSetDChain( )  				{	
	_u128 temp128;
	
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifSetDChain",(long)MipsCpu.PC );
#endif

 	temp128.lo = 0;
	MipsMemoryWrite( temp128, DATA_W, D5_QWC, 0);	//KSEG1_ADDR(D5_QWC)	= 0;
	
 	temp128.lo = 0x184;
	MipsMemoryWrite( temp128, DATA_W, D5_CHCR, 0);	//KSEG1_ADDR(D5_CHCR)	= 0x184;	// 0001 1000 0100

	MipsCpu.GPR[CPU_REG_SP].lo =  MipsCpu.GPR[CPU_REG_SP].lo - 0x10 ;	

	MipsMemoryRead( &temp128, DATA_W, D5_CHCR, 0 );	
	MipsMemoryWrite( temp128, DATA_W, MipsCpu.GPR[CPU_REG_SP].lo, 0);

	MipsCpu.GPR[CPU_REG_SP].lo =  MipsCpu.GPR[CPU_REG_SP].lo + 0x10 ;

	MipsCpu.PC = MipsCpu.PC + 4;
} 
 

static int reg4;
static u32 *soft_reg;



void SYSCALL_sceSifSetReg( ) 					{ 
char temp_string[256];

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifSetReg",(long)MipsCpu.PC );
#endif
/*
	if ( debug_thread == 1 ) {
		sprintf(temp_string,"(%d)[SIFSETREG] SIFSETREG: %8.8lx \n",Ps2Bios.PS2_Sched.RunningIDThread,MipsCpu.GPR[CPU_REG_A0].lo);PrintToEmuOutput (  temp_string ); 			}
*/

	switch (MipsCpu.GPR[CPU_REG_A0].lo) {
		case 0x8000001: // ??
		case 0x80000001:
			soft_reg = (_u32*)&MipsMemory [  (MipsCpu.GPR[CPU_REG_A1].lo + (7 * 4))& 0x01FFFFFF ];
			soft_reg[0] = 1;
			break;

		case 0x4:
			reg4 = MipsCpu.GPR[CPU_REG_A1].lo;
			break;

		default:
			break;
	}


//	MipsCpu.halt = 1; 

	MipsCpu.PC = MipsCpu.PC + 4;
}     

/*
sceSifGetReg
a0 ( _u16 ) : Register number
*/
void SYSCALL_sceSifGetReg( ) 					{
char temp_string[256];

	static int reg4_toggle=0;
	
#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifGetReg",(long)MipsCpu.PC );
#endif
/*
	if ( debug_thread == 1 ) {
		sprintf(temp_string,"(%d)[SIFGETREG] SIFGETREG: %8.8lx \n",Ps2Bios.PS2_Sched.RunningIDThread,MipsCpu.GPR[CPU_REG_A0].lo);PrintToEmuOutput (  temp_string ); 			}
*/


	switch (MipsCpu.GPR[CPU_REG_A0].lo) {

		case 0x8000000: // ??
		case 0x80000000:
			MipsCpu.GPR[CPU_REG_V0].lo = 0;
			break;

		case 0x80000002:
			MipsCpu.GPR[CPU_REG_V0].lo = 0;
			break;

		case 0x4:
//			v0.UD[0] = (reg4 & ~0x40000) | 0x20000;//for DC_SPEC.ELF
//			v0.UD[0] =  reg4 | 0x60000;//otherwise
			MipsCpu.GPR[CPU_REG_V0].lo = (reg4 | 0x20000) & ~0x40000;
			MipsCpu.GPR[CPU_REG_V0].lo|= reg4_toggle;
			reg4_toggle^=0x40000;
			break;

		default:
			MipsCpu.GPR[CPU_REG_V0].lo = 0x60000;
			break;

	}
	
	//MipsCpu.GPR[CPU_REG_V0].lo = 0x00060000;
	MipsCpu.PC = MipsCpu.PC + 4;
} 
 
void SYSCALL_sceSifStopDma( ) 					{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]sceSifStopDma",(long)MipsCpu.PC );
#endif

	MipsCpu.GPR[CPU_REG_V0].lo = 0x0;

//	MipsCpu.halt = 1; 

	MipsCpu.PC = MipsCpu.PC + 4;
}   


void SYSCALL_isceSifSetDChain( ) 				{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]isceSifSetDChain",(long)MipsCpu.PC );
#endif
	
	MipsCpu.halt = 1; 
}     



void SYSCALL_isceSifSetDma( ) 					{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]isceSifSetDma",(long)MipsCpu.PC );
#endif


	MipsCpu.halt = 1; 
}     



void SYSCALL_isceSifDmaStat( ) 					{ 

#ifdef SYSCALL_LOG
	SYSCALL_LOG("%8.8lx:[BIOS]isceSifDmaStat",(long)MipsCpu.PC );
#endif


	MipsCpu.halt = 1; 
}     


