/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>




#include "nSX2.h"
#include "PS2Edefs.h"

#include"_Debuger/debuger.h"

#include "main.h"

#include "Sif.h"
#include "pluggins_main.h"





void *DEBUGplugin = NULL ;

pluginDebuger DebugPlugin;

_u8 LoadDEBUGPluggin( char * filename ) {


	void *drv;
	
    if (DEBUGplugin) { 
		FreeLibrary((HMODULE)DEBUGplugin); 
	}  // * Free plugin
    
 	DEBUGplugin = LoadLibrary(filename);
	if (DEBUGplugin == NULL) { ShowMessage ("Could Not Load Debug Plugin %s\n", filename); return -1; }
	drv = DEBUGplugin;

	DBG_CloseDebuger 			=  SysLoadSym(drv, "DLL_CloseDebuger"); 
	DBG_OpenDebuger 			=  SysLoadSym(drv, "DLL_OpenDebuger"); 
	DBG_InitDebuger 			=  SysLoadSym(drv, "DLL_InitDebuger");
	DBG_ShutdownDebuger 		=  SysLoadSym(drv, "DLL_ShutdownDebuger"); 
	DBG_ShowHideDebuger 		=  SysLoadSym(drv, "DLL_ShowHideDebuger"); 
	DBG_SendBreak 				=  SysLoadSym(drv, "DLL_SendBreak"); 

	return ( 0);
}


void GUI_InitDebuger( HWND hwnd ) {		

		DebugPlugin.MipsMemory 			= MipsMemory;
		DebugPlugin.SpecialAreaMemory 	= SpecialAreaMemory;
		DebugPlugin.GSAreaMemory 		= GSAreaMemory;
		DebugPlugin.SPRMemory 			= SPRMemory;
		DebugPlugin.BiosMemory 			= BiosMemory;

		DebugPlugin.DmaC = &DmaC;
		DebugPlugin.GIF = &GIF;
		DebugPlugin.IntC = &IntC;
		DebugPlugin.Timer[0] = &Timer[0];
		DebugPlugin.Timer[1] = &Timer[1];
		DebugPlugin.Timer[2] = &Timer[2];
		DebugPlugin.Timer[3] = &Timer[3];
		DebugPlugin.Timer[4] = &Timer[4];
		DebugPlugin.Timer[5] = &Timer[5];
		DebugPlugin.Timer[6] = &Timer[6];
		DebugPlugin.VIF[0] = &VIF[0];
		DebugPlugin.VIF[1] = &VIF[1];
		DebugPlugin.VectorUnit0 = &VectorUnit0;
		DebugPlugin.VectorUnit1 = &VectorUnit1;
		DebugPlugin.MipsCpu = &MipsCpu;

		DebugPlugin.Ps2Bios	= &Ps2Bios;

		(*DBG_InitDebuger)( &DebugPlugin );
}

void GUI_ShutdownDebuger( HWND hwnd ) {		(*DBG_ShutdownDebuger)(  ); }



void GUI_OpenDebuger( HINSTANCE hwnd ) {	

		(*DBG_OpenDebuger)( hwnd );

}













