/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>




#include "nSX2.h"
#include "PS2Edefs.h"

#include"_Debuger/debuger.h"

#include "main.h"

#include "Sif.h"
#include "pluggins_main.h"


void *PAD1plugin = NULL;

#define LoadPAD1sym1(dest, name) \
	LoadSym(PAD1##dest, _PAD##dest, name, 1);

#define LoadPAD1sym0(dest, name) \
	LoadSym(PAD1##dest, _PAD##dest, name, 0); \
	if (PAD1##dest == NULL) PAD1##dest = (_PAD##dest) PAD1_##dest;


_u8 LoadInputPluggin( char * filename ) {
	void *drv;
	
	if (PAD1plugin != NULL) { FreeLibrary((HMODULE)PAD1plugin); }  // * Free plugin
	
	PAD1plugin = LoadLibrary(filename);
	if (PAD1plugin == NULL) { ShowMessage ("Could Not Load PAD1 Plugin %s\n", filename); return -1; }
	
    sprintf(InputPluginToUse,filename);
    
    drv = PAD1plugin;
	LoadPAD1sym1(init,         "PADinit");
	LoadPAD1sym1(shutdown,     "PADshutdown");
	LoadPAD1sym1(open,         "PADopen");
	LoadPAD1sym1(close,        "PADclose");
	LoadPAD1sym1(keyEvent,     "PADkeyEvent");
	LoadPAD1sym1(startPoll,    "PADstartPoll");
	LoadPAD1sym1(poll,         "PADpoll");
	LoadPAD1sym1(query,        "PADquery");

	LoadPAD1sym1(configure,    "PADconfigure");
	LoadPAD1sym1(about,        "PADabout");
	LoadPAD1sym1(test,         "PADtest");

	return 0; 
}






