/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/


static void (*cop1_opc[32])(void) =
{
	MFC1,	NI,		CFC1,	NI,		MTC1,	NI,		CTC1,	NI,
	BC1, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI,
	COP1_S,	NI, 	NI, 	NI, 	COP1_W,	NI,		NI, 	NI,
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI							
};



static char * debug_cop1_opc[32] =
{
	"MFC1",		"NI",	"CFC1",	"NI",	"MTC1",		"NI",	"CTC1",	"NI",
	"BC1",		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI",
	"COP1_S",	"NI", 	"NI", 	"NI", 	"COP1_W",	"NI",	"NI", 	"NI",
	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI"							
};


static void (*cop1_bc1_opc[4])(void) =
{
	BC1F, BC1T,
	BC1FL,BC1TL
};


static char * debug_cop1_bc1_opc[4] =
{
	"BC1F", "BC1T",
	"BC1FL","BC1TL"
};

static void (*cop1_s_opc[64])(void) =
{
	ADD_S, 		SUB_S, 		MUL_S, 		DIV_S, 		SQRT_S, 	ABS_S, 		MOV_S, 		NEG_S,
	NI,			NI,			NI,			NI,			NI,			NI,			NI,			NI,
	NI,			NI,			NI,			NI,			NI,			NI,		 	RSQRT_S,  	NI,
	ADDA_S, 	SUBA_S,		MULA_S,		NI, 		MADD_S,		MSUB_S,		MADDA_S,	MSUBA_S,		
	NI,			NI, 		NI, 		NI,			CVT_W_S,	NI,			NI,			NI,
	MAX_S, 		MIN_S, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	C_F_S, 		NI,			C_EQ_S,		NI	,		C_OLT_S,	NI,			C_OLE_S,	NI,
	NI,			NI, 		NI,			NI,			NI,			NI,			NI,			NI
};



static char * debug_cop1_s_opc[64] =
{
	"ADD_S", 	"SUB_S", 	"MUL_S", 	"DIV_S", 	"SQRT_S", 	"ABS_S", 	"MOV_S", 	"NEG_S",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",  		"RSQRT_S", 	"NI",
	"ADDA_S", 	"SUBA_S", 	"MULA_S", 	"NI", 		"MADD_S", 	"MSUB_S", 	"MADDA_S", 	"MSUBA_S",		
	"NI",		"NI", 		"NI", 		"NI",		"CVT_W_S",	"NI",		"NI",		"NI",
	"MAX_S", 	"MIN_S", 	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"C_F_S", 	"NI",		"C_EQ_S",	"NI",		"C_OLT_S",	"NI",		"C_OLE_S",	"NI",
	"NI",		"NI", 		"NI",		"NI",		"NI",		"NI",		"NI",		"NI"
};


static void (*cop1_W_L_opc[64])(void) =
{
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	CVTS_W,		NI,			NI, 	NI, 		NI, 		NI, 		NI, 	NI, 			
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI		
};



static char * debug_cop1_W_L_opc[64] =
{
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"CVT_S",	"NI",		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI"	
	
};

static void (*cop1_movcf_opc[2])(void) =	
{
	MOVF_fmt, MOVT_fmt	
};


static char * debug_cop1_movcf_opc[2] =
{
	"MOVF_fmt", "MOVT_fmt"	
};

