/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

static void (*special2_opc[64])(void) =
{
	MADD,	MADDU,	NI,		NI,		PLZCW,	NI,		NI,		NI,	
	MMI0,	MMI2,	NI,		NI,		NI,		NI,		NI,		NI,	
	MFHI1,	MTHI1,	MFLO1,	MTLO1,	NI,		NI,		NI,		NI,	
	MULT1,	MULTU1,	DIV1,	DIVU1,	NI,		NI,		NI,		NI,	
	MADD1,	MADDU1,	NI,		NI,		NI,		NI,		NI,		NI,	
	MMI1,	MMI3,	NI,		NI,		NI,		NI,		NI,		NI,	
	PMFHL,	PMTHL,	NI,		NI,		PSLLH,	NI,		PSRLH,	PSRAH,	
	NI,		NI,		NI,		NI,		PSLLW,	NI,		PSRLW,	PSRAW							
};



static char * debug_special2_opc[64] =
{
	"MADD",	"MADDU",	"NI",	"NI",	"PLZCW","NI",	"NI",	"NI",	
	"MMI0",	"MMI2",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MFHI1","MTHI1",	"MFLO1","MTLO1","NI",	"NI",	"NI",	"NI",	
	"MULT1","MULTU1",	"DIV1",	"DIVU1","NI",	"NI",	"NI",	"NI",	
	"MADD1","MADDU1",	"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MMI1",	"MMI3",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"PMFHL","PMTHL",	"NI",	"NI",	"PSLLH","NI",	"PSRLH","PSRAH",	
	"NI",	"NI",		"NI",	"NI",	"PSLLW","NI",	"PSRLW","PSRAW"							
};



static void (*Special2_MMI0[32])() =
{ 
 PADDW,		PSUBW,	PCGTW,	PMAXW,	PADDH,	PSUBH,	PCGTH,	PMAXH,        
 PADDB,		PSUBB,	PCGTB,	NI,		NI,		NI,		NI,		NI,
 PADDSW,	PSUBSW,	PEXTLW,	PPACW,	PADDSH,	PSUBSH,	PEXTLH,	PPACH,        
 PADDSB,	PSUBSB,	PEXTLB,	PPACB,	NI,		NI,		PEXT5,	PPAC5       
};

static char * debug_Special2_MMI0[32] =
{ 
 "PADDW",	"PSUBW",	"PCGTW",	"PMAXW",	"PADDH",	"PSUBH",	"PCGTH",	"PMAXH",        
 "PADDB",	"PSUBB",	"PCGTB",	"NI",		"NI",		"NI",		"NI",		"NI",
 "PADDSW",	"PSUBSW",	"PEXTLW",	"PPACW",	"PADDSH",	"PSUBSH",	"PEXTLH",	"PPACH",        
 "PADDSB",	"PSUBSB",	"PEXTLB",	"PPACB",	"NI",		"NI",		"PEXT5",	"PPAC5"      
};




static void (*Special2_MMI1[32])() =
{ 
 NI,   		PABSW,	PCEQW,	PMINW,	PADSBH, PABSH,  PCEQH,  PMINH, 
 NI,   		NI,   	PCEQB,  NI,		NI,   	NI,   	NI,   	NI, 
 PADDUW,    PSUBUW, PEXTUW, NI,   	PADDUH, PSUBUH, PEXTUH, NI, 
 PADDUB,    PSUBUB, PEXTUB, QFSRV,  NI,   	NI,   	NI,   	NI
};


static char * debug_Special2_MMI1[32] =
{ 
 "NI",   	"PABSW",	"PCEQW",	"PMINW",	"PADSBH", 	"PABSH",  	"PCEQH",  	"PMINH", 
 "NI",   	"NI",   	"PCEQB",  	"NI",		"NI",   	"NI",   	"NI",   	"NI", 
 "PADDUW",  "PSUBUW", 	"PEXTUW", 	"NI",   	"PADDUH", 	"PSUBUH", 	"PEXTUH",	"NI", 
 "PADDUB",  "PSUBUB", 	"PEXTUB", 	"QFSRV",  	"NI",   	"NI",   	"NI",   	"NI"
};


static void (*Special2_MMI2[32])() = 
{ 
 PMADDW,	NI,		PSLLVW,	PSRLVW,	PMSUBW,	NI,		NI,		NI,
 PMFHI,		PMFLO,	PINTH,	NI,		PMULTW,	PDIVW,	PCPYLD,	NI,
 PMADDH,	PHMADH,	PAND,	PXOR,	PMSUBH,	PHMSBH,	NI,		NI, 
 NI,		NI,		PEXEH,	PREVH,	PMULTH,	PDIVBW,	PEXEW,	PROT3W
};


static char * debug_Special2_MMI2[32] = 
{ 
 "PMADDW",	"NI",		"PSLLVW",	"PSRLVW",	"PMSUBW",	"NI",		"NI",		"NI",
 "PMFHI",	"PMFLO",	"PINTH",	"NI",		"PMULTW",	"PDIVW",	"PCPYLD",	"NI",
 "PMADDH",	"PHMADH",	"PAND",		"PXOR",		"PMSUBH",	"PHMSBH",	"NI",		"NI", 
 "NI",		"NI",		"PEXEH",	"PREVH",	"PMULTH",	"PDIVBW",	"PEXEW",	"PROT3W"
};


static void (*Special2_MMI3[32])() = 
{ 
 PMADDUW,	NI,		NI,		PSRAVW,	NI,		NI,		NI,		NI,
 PMTHI,		PMTLO,	PINTEH,	NI,		PMULTUW,PDIVUW,	PCPYUD,	NI,
 NI,		NI,		POR,	PNOR,	NI,		NI,		NI,		NI,
 NI,		NI,		PEXCH,	PCPYH,	NI,		NI,		PEXCW,	NI
};

static char * debug_Special2_MMI3[32] = 
{ 
 "PMADDUW",	"NI",		"NI",		"PSRAVW",	"NI",		"NI",		"NI",		"NI",
 "PMTHI",	"PMTLO",	"PINTEH",	"NI",		"PMULTUW",	"PDIVUW",	"PCPYUD",	"NI",
 "NI",		"NI",		"POR",		"PNOR",		"NI",		"NI",		"NI",		"NI",
 "NI",		"NI",		"PEXCH",	"PCPYH",	"NI",		"NI",		"PEXCW",	"NI"
};

